/* A YACC parser generated from "parser.y" */

# line 18
#ifndef lint
#define lint
#endif
#define defTycon(n,l,lhs,rhs,w)	 tyconDefn(intOf(l),lhs,rhs,w); sp-=n
#define sigdecl(l,vs,t)		 ap(SIGDECL,triple(l,vs,t))
#define fixdecl(l,ops,a,p)	 ap(FIXDECL,\
				    triple(l,ops,mkInt(mkSyntax(a,intOf(p)))))
#define grded(gs)		 ap(GUARDED,gs)
#define bang(t)			 ap(BANG,t)
#define only(t)			 ap(ONLY,t)
#define letrec(bs,e)		 (nonNull(bs) ? ap(LETREC,pair(bs,e)) : e)
#define qualify(ps,t)		 (nonNull(ps) ? ap(QUAL,pair(ps,t)) : t)
#if IGNORE_MODULES
#define exportSelf()		 NIL
#else
#define exportSelf()		 singleton(ap(MODULEENT,mkCon(module(currentModule).text)))
#endif
#define yyerror(s)		 /* errors handled elsewhere */
#define YYSTYPE			 Cell

static Cell   local gcShadow	 Args((Int,Cell));
static Void   local syntaxError	 Args((String));
static String local unexpected	 Args((Void));
static Cell   local checkPrec	 Args((Cell));
static Cell   local buildTuple	 Args((List));
static List   local checkContext Args((List));
static Cell   local checkPred	 Args((Cell));
static Pair   local checkDo	 Args((List));
static Cell   local checkTyLhs	 Args((Cell));
#if !TREX
static Void   local noTREX	 Args((String));
#endif
#if !IPARAM
static Void   local noIP	 Args((String));
#endif

/* For the purposes of reasonably portable garbage collection, it is
 * necessary to simulate the YACC stack on the Hugs stack to keep
 * track of all intermediate constructs.  The lexical analyser
 * pushes a token onto the stack for each token that is found, with
 * these elements being removed as reduce actions are performed,
 * taking account of look-ahead tokens as described by gcShadow()
 * below.
 *
 * Of the non-terminals used below, only start, topDecl & begin
 * do not leave any values on the Hugs stack.  The same is true for the
 * terminals EXPR and SCRIPT.  At the end of a successful parse, there
 * should only be one element left on the stack, containing the result
 * of the parse.
 */

#define gc0(e)			gcShadow(0,e)
#define gc1(e)			gcShadow(1,e)
#define gc2(e)			gcShadow(2,e)
#define gc3(e)			gcShadow(3,e)
#define gc4(e)			gcShadow(4,e)
#define gc5(e)			gcShadow(5,e)
#define gc6(e)			gcShadow(6,e)
#define gc7(e)			gcShadow(7,e)

#define EXPR 257
#define SCRIPT 258
#define CASEXP 259
#define OF 260
#define DATA 261
#define TYPE 262
#define IF 263
#define THEN 264
#define ELSE 265
#define WHERE 266
#define LET 267
#define IN 268
#define INFIXN 269
#define INFIXL 270
#define INFIXR 271
#define PRIMITIVE 272
#define TNEWTYPE 273
#define DEFAULT 274
#define DERIVING 275
#define DO 276
#define TCLASS 277
#define TINSTANCE 278
#define DWHERE 279
#define DLET 280
#define REPEAT 281
#define ALL 282
#define NUMLIT 283
#define CHARLIT 284
#define STRINGLIT 285
#define VAROP 286
#define VARID 287
#define CONOP 288
#define CONID 289
#define QVAROP 290
#define QVARID 291
#define QCONOP 292
#define QCONID 293
#define RECSELID 294
#define IPVARID 295
#define COCO 296
#define UPTO 297
#define FROM 298
#define ARROW 299
#define IMPLIES 300
#define TMODULE 301
#define IMPORT 302
#define HIDING 303
#define QUALIFIED 304
#define ASMOD 305
#define NEEDPRIMS 306
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

#line 951


static Cell local gcShadow(n,e)		/* keep parsed fragments on stack  */
Int  n;
Cell e; {
    /* If a look ahead token is held then the required stack transformation
     * is:
     *   pushed: n               1     0          1     0
     *           x1  |  ...  |  xn  |  la   ===>  e  |  la
     *                                top()            top()
     *
     * Othwerwise, the transformation is:
     *   pushed: n-1             0        0
     *           x1  |  ...  |  xn  ===>  e
     *                         top()     top()
     */
    if (yychar>=0) {
	pushed(n-1) = top();
	pushed(n)   = e;
    }
    else
	pushed(n-1) = e;
    sp -= (n-1);
    return e;
}

static Void local syntaxError(s)	/* report on syntax error	   */
String s; {
    ERRMSG(row) "Syntax error in %s (unexpected %s)", s, unexpected()
    EEND;
}

static String local unexpected() {     /* find name for unexpected token   */
    static char buffer[100];
    static char *fmt = "%s \"%s\"";
    static char *kwd = "keyword";

    switch (yychar) {
	case 0         : return "end of input";

#define keyword(kw) sprintf(buffer,fmt,kwd,kw); return buffer;
	case INFIXL    : keyword("infixl");
	case INFIXR    : keyword("infixr");
	case INFIXN    : keyword("infix");
	case TINSTANCE : keyword("instance");
	case TCLASS    : keyword("class");
	case PRIMITIVE : keyword("primitive");
	case CASEXP    : keyword("case");
	case OF        : keyword("of");
	case IF        : keyword("if");
	case THEN      : keyword("then");
	case ELSE      : keyword("else");
	case WHERE     : keyword("where");
	case TYPE      : keyword("type");
	case DATA      : keyword("data");
	case TNEWTYPE  : keyword("newtype");
	case LET       : keyword("let");
	case IN        : keyword("in");
	case DERIVING  : keyword("deriving");
	case DEFAULT   : keyword("default");
	case IMPORT    : keyword("import");
	case TMODULE   : keyword("module");
	case ALL       : keyword("forall");
#if IPARAM
	case DLET      : keyword("dlet");
	case DWHERE    : keyword("with");
#endif
#undef keyword

	case ARROW     : return "`->'";
	case '='       : return "`='";
	case COCO      : return "`::'";
	case '-'       : return "`-'";
	case '!'       : return "`!'";
	case ','       : return "comma";
	case '@'       : return "`@'";
	case '('       : return "`('";
	case ')'       : return "`)'";
	case '{'       : return "`{', possibly due to bad layout";
	case '}'       : return "`}', possibly due to bad layout";
	case '_'       : return "`_'";
	case '|'       : return "`|'";
	case '.'       : return "`.'";
	case ';'       : return "`;', possibly due to bad layout";
	case UPTO      : return "`..'";
	case '['       : return "`['";
	case ']'       : return "`]'";
	case FROM      : return "`<-'";
	case '\\'      : return "backslash (lambda)";
	case '~'       : return "tilde";
	case '`'       : return "backquote";
#if TREX
	case RECSELID  : sprintf(buffer,"selector \"#%s\"",
				 textToStr(extText(snd(yylval))));
			 return buffer;
#endif
#if IPARAM
	case IPVARID   : sprintf(buffer,"implicit parameter \"?%s\"",
				 textToStr(textOf(yylval)));
			 return buffer;
#endif
	case VAROP     :
	case VARID     :
	case CONOP     :
	case CONID     : sprintf(buffer,"symbol \"%s\"",
				 textToStr(textOf(yylval)));
			 return buffer;
	case QVAROP    :
	case QVARID    :
	case QCONOP    : 
	case QCONID    : sprintf(buffer,"symbol \"%s\"",
				 identToStr(yylval));
			 return buffer;
	case HIDING    : return "symbol \"hiding\"";
	case QUALIFIED : return "symbol \"qualified\"";
	case ASMOD     : return "symbol \"as\"";
	case NUMLIT    : return "numeric literal";
	case CHARLIT   : return "character literal";
	case STRINGLIT : return "string literal";
	case IMPLIES   : return "`=>'";
	default        : return "token";
    }
}

static Cell local checkPrec(p)		/* Check for valid precedence value*/
Cell p; {
    if (!isInt(p) || intOf(p)<MIN_PREC || intOf(p)>MAX_PREC) {
	ERRMSG(row) "Precedence value must be an integer in the range [%d..%d]",
		    MIN_PREC, MAX_PREC
	EEND;
    }
    return p;
}

static Cell local buildTuple(tup)	/* build tuple (x1,...,xn) from	   */
List tup; {				/* list [xn,...,x1]		   */
    Int  n = 0;
    Cell t = tup;
    Cell x;

    do {				/*    .                    .	   */
	x      = fst(t);		/*   / \                  / \	   */
	fst(t) = snd(t);		/*  xn  .                .   xn	   */
	snd(t) = x;			/*       .    ===>      .	   */
	x      = t;			/*        .            .	   */
	t      = fun(x);		/*         .          .		   */
	n++;				/*        / \        / \	   */
    } while (nonNull(t));		/*       x1  NIL   (n)  x1	   */
    fst(x) = mkTuple(n);
    return tup;
}

static List local checkContext(con)	/* validate context		   */
Type con; {
    mapOver(checkPred, con);
    return con;
}

static Cell local checkPred(c)		/* check that type expr is a valid */
Cell c; {				/* constraint			   */
    Cell cn = getHead(c);
#if TREX
    if (isExt(cn) && argCount==1)
	return c;
#endif
#if IPARAM
    if (isIP(cn))
	return c;
#endif
    if (!isQCon(cn) || argCount==0)
	syntaxError("class expression");
    return c;
}

static Pair local checkDo(dqs)		/* convert reversed list of dquals */
List dqs; {				/* to an (expr,quals) pair         */
    if (isNull(dqs) || whatIs(hd(dqs))!=DOQUAL) {
	ERRMSG(row) "Last generator in do {...} must be an expression"
	EEND;
    }
    fst(dqs) = snd(fst(dqs));		/* put expression in fst of pair   */
    snd(dqs) = rev(snd(dqs));		/* & reversed list of quals in snd */
    return dqs;
}

static Cell local checkTyLhs(c)		/* check that lhs is of the form   */
Cell c; {				/* T a1 ... a			   */
    Cell tlhs = c;
    while (isAp(tlhs) && whatIs(arg(tlhs))==VARIDCELL) {
	tlhs = fun(tlhs);
    }
    if (whatIs(tlhs)!=CONIDCELL) {
	ERRMSG(row) "Illegal left hand side in datatype definition"
	EEND;
    }
    return c;
}

#if !TREX
static Void local noTREX(where)
String where; {
    ERRMSG(row) "Attempt to use TREX records while parsing %s.\n", where ETHEN
    ERRTEXT     "(TREX is disabled in this build of Hugs)"
    EEND;
}
#endif
#if !IPARAM
static Void local noIP(where)
String where; {
    ERRMSG(row) "Attempt to use Implicit Parameters while parsing %s.\n", where ETHEN
    ERRTEXT     "(Implicit Parameters are disabled in this build of Hugs)"
    EEND;
}
#endif

/*-------------------------------------------------------------------------*/
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 131,
	300, 164,
	-2, 183,
-1, 163,
	61, 448,
	-2, 406,
-1, 261,
	296, 236,
	44, 236,
	-2, 274,
-1, 269,
	300, 163,
	-2, 201,
-1, 344,
	61, 448,
	-2, 322,
-1, 388,
	256, 72,
	59, 72,
	125, 72,
	-2, 85,
-1, 390,
	300, 164,
	-2, 75,
-1, 407,
	300, 164,
	-2, 143,
-1, 411,
	300, 164,
	-2, 145,
-1, 458,
	40, 438,
	-2, 451,
-1, 459,
	44, 449,
	41, 449,
	123, 449,
	-2, 439,
-1, 461,
	300, 165,
	-2, 204,
-1, 464,
	300, 166,
	-2, 206,
-1, 567,
	300, 164,
	-2, 197,
-1, 648,
	300, 164,
	-2, 100,
	};
#define YYNPROD 482
# define YYLAST 3462
short yyact[]={

  41, 675, 645, 789, 127, 777, 562, 257, 767, 644,
 761, 779, 692, 662,  24, 642, 641, 556, 565, 489,
 382,   8, 646, 305, 632, 292, 714, 480, 182, 615,
   9, 452,  40, 414, 635, 116, 401, 387, 195, 188,
 342, 187, 234, 555, 185, 526, 442, 420, 240, 183,
 235, 239, 711, 135, 478, 128, 379,  66,  66, 374,
 278, 147, 241,  90, 162, 384, 242, 157, 616,  49,
 716, 529, 674, 546, 544,  50, 331,   6, 539, 534,
 737,  66, 359, 186, 268, 754, 633,  56,  56, 680,
  43, 164, 149, 529, 386, 678, 476, 520, 385, 115,
 231, 518, 569, 309, 801, 332,  44,  45,  46, 649,
  43, 103, 164, 383, 288, 126, 647, 194, 431, 678,
 269, 170, 529, 115, 217, 217,  44,  45,  46, 608,
 329, 135, 287, 216, 218, 139,  53, 287, 284, 138,
 541,  43, 287, 149, 771, 148, 141, 150,  66, 431,
 142, 149, 158,  52, 418, 136, 657,  44,  45,  46,
 260, 264, 542, 263, 500, 330,  43, 141, 139, 388,
 141, 142, 138, 281, 142,  43, 429, 149,  56, 168,
 232, 150,  44,  45,  46, 271, 168, 124,  51, 389,
 149,  44,  45,  46, 150, 359,  68, 386, 720, 713,
 614, 385, 389, 425, 427, 424,  65, 343,  57,  69,
 399, 332, 449, 710, 356, 367, 202, 421, 332, 199,
 125, 203, 165, 310, 348, 351, 140, 275, 355, 360,
 515, 425, 425, 154,   4,   2,   3, 398, 196, 260,
 264, 423, 263, 613, 712, 394, 394, 391, 396, 394,
 394, 406, 410, 361, 122, 511, 362, 535, 378,  60,
 557, 334, 105, 350, 336, 337, 186, 306, 311, 287,
 259, 287, 258, 616, 412, 291, 114,  61, 421, 287,
 306, 732, 453, 481, 287, 584, 764, 422, 418, 483,
 287, 287, 810,  91, 460,  76, 287,  64, 304, 192,
  94,  59,  97,  74, 447, 264,  43, 263, 437, 482,
 105, 279, 486, 301, 300, 484, 485, 605, 289, 306,
 607, 169,  44,  45,  46, 498, 299, 164, 298,  43,
 287, 637, 655, 490, 528, 279, 638, 676, 160, 334,
 336, 337,  43, 178, 139,  44,  45,  46, 138, 417,
 495, 421, 496, 233, 273, 499, 528, 294,  44,  45,
  46, 676, 503,  43, 506, 459,  43, 178, 139, 138,
 811, 230, 138, 809, 497, 514, 491, 493, 273,  44,
  45,  46,  44,  45,  46, 528, 158, 527, 532, 415,
  64, 287, 540, 139, 394, 713, 287, 138, 307, 168,
 606, 430,  95,  64, 530, 346, 672,  59, 287, 335,
  64, 307, 287, 287,  59, 352, 287, 475, 229, 516,
 260, 264, 610, 263,  38, 322, 134, 513, 324, 313,
 524, 135, 523, 564, 381, 380, 207, 522, 549, 147,
 521, 550,  43, 217, 525,  80, 308, 819, 537,  67,
 307,  64, 554,  62, 345,  59,  93, 800,  44,  45,
  46, 799, 752, 135, 287, 180, 135, 553, 394,  43,
 560, 287, 561,  37, 287, 287, 707, 588, 287, 577,
 543, 306, 132, 417, 545,  44,  45,  46, 274, 592,
 413, 366, 551, 105,  54, 437, 598, 426, 428, 599,
 600, 163,  80,  43, 169, 139,  70, 181, 323, 138,
 143, 609, 673, 181,  80, 212, 176, 670, 214,  44,
  45,  46, 163, 439, 443, 444, 174, 343, 314, 177,
 519, 512, 287,  43, 135,  42, 446, 287, 445, 135,
 333, 135, 623, 564, 312, 211, 261, 665, 630,  44,
  45,  46, 660, 622, 663, 661, 603, 640, 286, 604,
 147, 260, 264, 286, 263, 818, 654, 135, 287, 568,
 287, 654, 656, 629, 798, 797, 639, 664, 666, 627,
 295, 325, 755, 773, 671, 794, 773, 253, 772,  19,
 753, 287, 751,  80, 750, 287, 215, 287, 213, 744,
  80, 453, 693, 287, 140, 287,  75, 287, 697, 287,
 706, 669, 307, 277,  80,  96,  80, 344, 687, 617,
 583, 271,  80, 260, 264, 261, 263, 685, 585, 358,
 699, 586, 695, 131, 698, 696, 650, 581, 217, 490,
 274, 650, 701, 472, 715, 517, 473, 703, 135, 287,
 287, 287, 334, 287, 287, 471, 705, 532, 220, 709,
 394, 721, 394, 226, 469, 532, 253, 470, 287, 287,
 466, 287, 403, 467, 223, 287, 704, 715, 468, 481,
 287, 287, 287, 370,  80, 206,  80, 700, 369, 228,
 448, 740, 359, 741, 455, 227, 738, 286, 746, 747,
 748, 558, 271, 745, 558, 286, 558, 140, 291, 749,
 722, 270, 140, 135, 140, 736, 225, 287, 287, 287,
 457, 686, 286, 287, 287, 287, 287, 287, 769, 181,
 783, 784, 287, 224, 135, 287, 287, 163, 135, 774,
 790, 763, 756, 287, 287, 654, 181, 222, 181, 654,
 792, 793,  80, 663, 464, 765,  80, 465, 181,  80,
 181,  80,  80, 280, 221, 795, 654, 693, 319, 173,
 654, 181, 318, 135, 806, 457, 287, 287, 722, 287,
  55, 320, 805, 287, 321, 722, 722, 708, 808, 291,
 807, 727, 730, 219, 631, 135, 220, 128, 393, 814,
 210, 587, 135, 211, 564, 654, 261, 267, 817, 816,
 815,  63, 287, 821, 820, 650,  58, 286, 790, 650,
 591, 373, 286, 595, 287, 390, 395, 357, 208, 407,
 411, 209, 763, 205, 286, 359, 650, 822, 286, 722,
 650, 359,  99, 722, 204, 812, 813, 253, 140, 825,
 161, 102, 156, 140, 140, 140, 571, 781, 573, 576,
 612, 475, 328, 477, 573, 785, 611, 733, 573, 573,
 786,  80, 488,  80, 117, 650, 277, 100,  77, 120,
  16, 155, 487,  78,  17,  10, 140,  12, 341, 172,
 140, 193, 171, 340, 419, 285, 416, 136, 574, 572,
 285, 433, 252, 201, 286, 578, 200, 140, 251, 579,
 580, 140, 479, 501, 276, 133, 504, 272, 507, 509,
 788, 129, 570, 548, 274, 547, 717,  80, 724, 725,
  80, 282, 408,  80, 404,  80, 400, 344, 181,  43,
 167, 637, 803, 802, 787, 589, 140, 261, 593, 653,
 597, 558, 198, 189, 636,  44,  45,  46, 652, 766,
 591, 238, 595, 286, 760, 758, 403,  43, 140, 459,
 634,  37, 691, 458, 536, 140, 689, 451, 236, 266,
 123, 456, 141,  44,  45,  46, 142, 720, 253, 121,
  48,  47,   1,   0, 286, 531, 286,   0,   0, 782,
   0,   0,   0, 393,   0, 274,  80,  80,  80, 261,
 359, 567,   0, 455, 409,   0, 282, 286,   0,   0,
   0, 286,  43, 286,  42,   0,  37,   0,  39,   0,
   0, 317,   0,   0, 285, 181, 274,   0,  44,  45,
  46,   0, 285, 590,   0,  43, 594, 139, 596, 277,
 253, 138, 338, 717, 339,   0, 636, 402,   0, 285,
   0,  44,  45,  46,   0,   0,   0, 141,   0, 293,
   0, 142,   0,   0,   0, 286,   0, 286,   0, 286,
 286,   0,  43,   0, 618,   0,   0, 619,  43,   0,
 620,   0, 621,  43, 286, 286,   0,   0,  44,  45,
  46, 274,   0, 651,  44,  45,  46,   0, 651,  44,
  45,  46,   0,   0, 648,   0,   0,   0,   0, 648,
   0, 567, 432,   0, 435, 667,   0, 668,   0, 327,
 277,  81, 636, 762, 274, 768, 677,   0,   0,   0,
 770,   0, 589,   0, 593, 286,   0, 270,   0, 286,
 286, 327,   0, 286, 285,   0,   0, 791, 286, 285,
   0, 286, 286,   0, 764,   0,   0,   0, 759, 286,
   0, 285,   0,   0,  84, 285,   0,  29,  43,  64,
 139,   0,   0, 590, 138, 594, 457, 450,  29,  29,
 338,  29,   0,   0,  44,  45,  46,  29, 804,   0,
  29,   0, 286,   0,   0,   0,   0,   0,   0,  29,
   0,  29,   0,   0, 190,   0,   0, 677, 719, 405,
 190,  43, 728, 729, 762, 768,   0,   0, 270,  29,
 723,   0, 279,   0,   0, 791,   0,  44,  45,  46,
 734, 285, 735,   0,   0,  29, 824,   0, 677,  29,
  43,   0, 139, 190, 457, 742, 138,  43, 690, 477,
 742, 742, 742,  43,   0, 139,  44,  45,  46, 138,
  29,   0,   0,  44,  45,  46,   0,  29,  29,  44,
  45,  46, 651,  29,   0, 327, 651, 780, 327,   0,
 327, 327,   0, 648, 780, 780,   0, 775, 723,   0,
 285,   0,   0, 651,   0, 723, 723, 651,   0, 432,
 176, 435, 375, 677, 648,   5,   0,   0, 648,  29,
 174,   0, 314, 177, 477,   0,  29,  73,   0,   0,
   0, 285, 190, 285,  82,  92,   0,   0,   0, 197,
   0,  29, 651,   0,   0, 719, 677,  98,   0, 119,
   0,   0, 780, 648, 285,   0,   0, 477, 285, 723,
 285,   0,   0, 723,   0,   0, 393,   0,   0,   0,
   0,   0,   0,   0,  29, 131,   0,  29,  29,   0,
   0, 677, 567,   0,  29,  88,  29, 118,  29,  87,
  29,   0,   0,   0,   0,   0,   0, 190,   0,   0,
   0,   0,   0,   0,  29,   0,  29,  29,  29, 393,
   0,  43, 285,  42, 285,   0, 285, 285,   0,  28,
  89, 757,   0,   0,   0,   0,   0,  44,  45,  46,
   0, 285, 285,  43,   0, 459, 190,  37,   0, 458,
  83,   0, 454,   0, 682, 683, 684, 456,   0,  44,
  45,  46,   0, 190,   0, 190, 327,   0, 176, 327,
   0,   0, 327,   0, 327, 190,   0, 190, 174,   0,
 314, 177,   0,   0, 718,   0,   0,   0, 190, 316,
   0, 678, 285,  29,  29,   0, 285, 285,  29,   0,
 285,   0,   0,   0,   0, 285,   0,  83, 285, 285,
   0,  43, 191,  42,   0,  37, 285,  39, 191,  83,
   0, 688, 347, 190,   0, 353, 354,  44,  45,  46,
   0,  68, 363,   0, 364,   0, 365,   0,   0,   0,
   0, 440, 141, 441,  69,   0, 142, 720,   0, 285,
   0, 191, 371,   0, 372,   0, 377,   0,   0, 265,
   0,   0,   0,   0, 197,   0,   0, 678, 476,   0,
   0, 115,   0, 173,   0, 190, 190, 315, 237,   0,
   0, 190,   0,   0,   0, 190, 190, 184,  85,  86,
   0,  43, 397,  42, 559, 282, 601,  39,  83, 602,
   0,   0,   0,  29,   0, 191,  29,  44,  45,  46,
  88,   0,   0,   0,  87,   0,   0,   0, 141,  83,
   0,  83, 142,  43,   0, 139,   0, 191,   0, 138,
 191,   0, 492,   0,   0, 392, 494,   0,   0,  44,
  45,  46,   0,   0,   0,  89, 141,   0,   0, 109,
 142,   0,   0,   0,   0, 190,  34, 104,   0, 107,
 115, 108, 110, 176, 190,   0,  43,   0, 139,   0,
   0,   0, 138, 174,   0, 314, 177,   0,   0,   0,
   0,   0,  44,  45,  46,   0,   0,   0,   0,  83,
   0,  83,   0,   0,   0, 191,   0,   0,   0,   0,
  29,  29,   0,  29,  29,  29,   0,  36,  20,   0,
   0,  27,  60,   0,   0,   0,   0,   0,   0,   0,
   0, 173,   0, 178, 265, 315, 190, 179,   0, 197,
   0,   0,   0,   0, 191,   0,   0,   0,  43,  64,
 139, 552,  25, 237, 138,   0,   0,   0,   0,   0,
   0, 191, 190, 191,  44,  45,  46,  83,   0,   0,
   0, 191,   0, 191, 191, 191, 191, 191,   0,   0,
   0, 454, 694,   0,   0,  88, 191,   0,   0,  87,
 244, 243,   0, 279,  67,   0,  64,   0, 254, 255,
 256, 247, 245, 250, 265,   0, 248, 249,  29, 197,
   0,  29, 262,  85,  86,   0,  43,   0,  42, 676,
  89, 191,  39,   0,  43,   0, 139,   0,   0,   0,
 138, 242,  44,  45,  46, 246, 273,   0,   0,   0,
  44,  45,  46,   0,   0,   0,   0,   0, 624, 625,
   0, 626,  43, 628, 139,  88,   0,   0, 138,  87,
   0,   0,   0,   0, 463,   0,   0,  29,  44,  45,
  46,   0,  34, 191, 191,   0,   0,  13,   0, 191,
   0,   0,   7, 191, 191,  14,  83,   0,  83,  22,
  89,  68,   0,  21,   0,   0,   0,   0,   0,   0,
   0, 440,  15, 441,  69,   0,  23,  33,   0,  30,
  31,  32, 106,  43, 112,  42, 111,  37, 113,  39,
  35,  26,   0,  36,  20, 118, 173,  27, 178,  44,
  45,  46,   0,  34,   0,   0,   0,   0,  13,   0,
   0,   0, 191,   0,   0, 191, 702, 694, 191,  29,
 191,   0,   0, 191, 438, 244, 243,   0,  25,   0,
   0,   0, 191, 254, 255, 256, 247, 245, 250,   0,
   0, 248, 249,   0,   0,   0,   0, 262,  85,  86,
   0,  43,   0,  42,  36,  20,   0,  39,  27,   0,
   0,   0,   0,   0,   0,   0,   0,  44,  45,  46,
 246,   0,   0,  34,   0, 739,   0,   0,  13,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,  25,
   0,  83,  83,  83, 191, 244, 243,   0,   0,   0,
   0,   0,   0, 254, 255, 256, 247, 245, 250,   0,
   0, 248, 249,   0,   0,   0,   0, 262,  85,  86,
 191,  43,   0,  42,  36,  20,   0,  39,  27,  34,
 368,   0,   0,   0, 151,   0,   0,  44,  45,  46,
 246,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0, 796,   7,  25,
   0,  14,   0,   0,   0,  22,   0,   0,   0,  21,
   0,   0,   0, 678, 269,   0, 566, 115,  15,   0,
  36,  20,  23,  33,  27,  30,  31,  32,   0,  43,
  11,  42,   0,  37,   0,  39,  35,  26,  18,   0,
   0,   0,   0,   0,  71,  44,  45,  46,  34,   0,
   0,   0,  72,  13,  67,  25,  64,   0,   0,   7,
  59,   0,  14,   0, 141, 101,  22, 141, 142, 282,
  21, 142,   0,   0,   0,   0,   0,   0,   0,  15,
   0,   0,   0,  23,  33, 145,  30,  31,  32,   0,
  43,   0,  42, 146,  37,   0,  39,  35,  26,  36,
  20, 152,   0,  27,   0,   0,  44,  45,  46, 153,
   0,   0,   0,   0,   0,   0,   0,   0,  34,   0,
 141,   0,   0,  13, 142,   0,   0,   0,   0,   7,
   0,   0,  14,   0,  25,   0,  22,   0,   0,  71,
 376,   0,   0,   0,   0,   0,   0,  72,   0,  15,
   0,  34, 223,  23,  33,   0,  30,  31,  32,   0,
  43,   0,  42,   0,  37,   0,  39,  35,  26,  36,
  20,   0,   0,  27,   0, 296,  44,  45,  46,   0,
   0,   0, 302, 297,  34,   0,   0,   0,  14, 151,
 303,   0,  22,   0,   0,   0,  21,   0,   0,   0,
   0,   0,  36,  20,  25,  15,  27,   0,   0,  23,
  33,   0,  30,  31,  32,   0,  43,   0,  42,   0,
  37,   0,  39,  35,  26,   0,   0,   0,   0, 279,
   0,   0,  44,  45,  46,  36,  20,  25,   0,  27,
   0,   0,   0,   0,   0,   0, 152,   0,   0,   0,
   0,   0,   0,  34, 153, 676,   0,   0, 144,   0,
  43,   0, 139,  43,   0, 139, 138,  14,   0, 138,
  25,  22, 273,   0,   0,  21,  44,  45,  46,  44,
  45,  46,   0,   0,  15, 279,   0,   0,  23,  33,
   0,  30,  31,  32,   0,  43,   0,  42,   0,  37,
  34,  39,  35,  26,  36,  20,   0,   0,  27,   0,
   0,  44,  45,  46,   0,   0,  43,  68, 139,   0,
   0,   0, 138,   0,  82,   0,   0, 434,   0, 436,
  69,   0,  44,  45,  46,   0,   0,  14,   0,  25,
   0,  22,   0,   0,   0, 159,   0,   0, 168,   0,
   0,  36,  20,   0,  15,  27,   0,  34,  23,  33,
   0,  30,  31,  32,   0,  43,   0,  42,   0,  37,
  14,  39,  35,  26,  22,  88,   0,   0,  21,  87,
 438,  44,  45,  46,   0,   0,  25,  15,   0,  82,
 223,  23,  33,   0,  30,  31,  32,   0,  43,   0,
  42,   0,  37,  14,  39,  35,  26,  22,  36,   0,
  89,  21,  27,   0,  44,  45,  46,   0,   0,   0,
  15,   0,   0,   0,  23,  33,   0,  30,  31,  32,
   0,  43,   0,  42,   0,  37,  82,  39,  35,  26,
  88, 197,   0,  25,  87,   0,   0,  44,  45,  46,
   0,   0,   0, 176,   0,   0,   0,   0,   0,   0,
 265, 104,   0, 174, 115, 175, 177,   0,   0,   0,
   0,   0,  14,   0,   0,  89,  22,   0,   0,   0,
  21,   0,   0,   0,   0,   0,   0,  88,   0,  15,
   0,  87,   0,  23,  33,   0,  30,  31,  32,   0,
  43,   0,  42,   0,  37, 265,  39,  35,  26,   0,
 197,  88,   0,   0,   0,  87,  44,  45,  46,  14,
   0, 176,  89,  22, 349,   0,   0,  21,  82, 104,
   0, 174, 115, 175, 177,   0,  15,   0,   0,   0,
  23,  33,   0,  30,  31,  32,  89,  43,   0,  42,
   0,  37,   0,  39,  35,  26,  88,   0,  82, 582,
  87,   0,   0,  44,  45,  46,   0,  79,  85,  86,
  67,  43,  64,  42,   0,   0,  59,  39,   0,  88,
   0,   0,   0,  87,   0,   0,   0,  44,  45,  46,
 306,  89,  82,   0,   0,   0,   0, 197,  33,   0,
  30,  31,  32,   0,  43, 326,  42,   0,  37,  88,
  39,  35,  26,  87,  89,   0,  82,   0,   0,   0,
  44,  45,  46,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  79,  85,  86,   0,  43,   0,  42,   0,
  82,   0,  39,  88,  89, 510,   0,  87,   0,   0,
   0,   0,  44,  45,  46,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,  82,   0,  88,   0,   0,
 508,  87,   0,   0,   0,   0,   0,   0,  89, 184,
  85,  86,   0,  43,   0,  42,   0,   0,   0,  39,
   0,  88,  82,   0,   0,  87,   0, 505,   0,  44,
  45,  46,  89, 262,  85,  86, 173,  43, 178,  42,
   0,   0, 179,  39,   0,   0,  88,   0,   0,   0,
  87, 307,   0,  44,  45,  46,  89,   0,  82,   0,
   0,   0,   0, 502, 254, 255, 256,   0,   0,   0,
   0,   0,   0,  88,   0,   0,   0,  87, 262,  85,
  86,  89,  43,   0,  42,   0,   0,  82,  39,   0,
   0,   0,   0,   0,  82,   0,   0,   0,  44,  45,
  46, 184,  85,  86, 173,  43, 178,  42,  89,  88,
 179,  39, 823,  87,   0,   0,   0,   0,   0, 678,
   0,  44,  45,  46,   0,   0, 282, 476,   0,   0,
 115,  79,  85,  86,   0,  43,   0,  42,  88,   0,
   0,  39,  87,   0,  89,  88, 282, 269,   0,  87,
 115,  44,  45,  46,   0,   0,   0,   0,   0,   0,
   0,   0, 326,   0,   0, 575,  85,  86,   0,  43,
 141,  42,   0,  89, 142,  39,   0, 141,   0,   0,
  89, 142,   0,   0,   0,  44,  45,  46,   0,  79,
  85,  86,   0,  43,   0,  42, 130, 141,   0,  39,
   0, 142,   0,   0,   0,   0,   0,   0,   0,  44,
  45,  46,   0,  79,  85,  86,   0,  43, 649,  42,
   0,   0,   0,  39,   0, 647,   0,   0, 282, 461,
   0,   0, 462,  44,  45,  46,   0,   0,  79,  85,
  86,   0,  43,   0,  42,   0, 649, 141,  39,   0,
   0, 142,   0, 776,   0,   0,   0,   0,  44,  45,
  46,   0,   0,   0,   0,  79,  85,  86,   0,  43,
   0,  42,   0, 282, 658,  39, 141, 659,   0, 141,
 142,   0,   0, 142,   0,  44,  45,  46,   0,   0,
   0, 778,   0, 282,   0,   0,   0,   0, 678,   0,
   0,  79,  85,  86, 141,  43,   0,  42, 142,   0,
   0,  39, 731,   0,   0,   0,   0,   0,   0, 678,
   0,  44,  45,  46, 141,   0, 282,   0, 142,   0,
  79,  85,  86,   0,  43, 279,  42,  79,  85,  86,
  39,  43, 279,  42, 141,   0, 166,  39, 142, 141,
  44,  45,  46, 142,   0,   0, 726,  44,  45,  46,
   0, 676, 279, 678,   0,   0,  43,   0, 139,   0,
 141, 282, 138,  43, 142, 139, 566, 141,   0, 138,
   0, 142,  44,  45,  46, 273,   0,   0,   0,  44,
  45,  46,   0,  43,   0, 139, 282,   0,   0, 138,
   0,   0,   0, 282,   0, 273,   0,   0,   0,  44,
  45,  46, 137,   0, 141,   0,   0, 538, 142,   0,
   0,   0, 141,   0, 533, 282, 142, 141, 282,   0,
   0, 142,   0,   0,   0,   0,   0,   0,   0,   0,
   0, 655,   0,  43,   0, 139,   0, 141, 282, 138,
   0, 142,   0, 282, 141,   0, 743,   0, 142,  44,
  45,  46,   0,   0,   0,   0,   0, 643,   0, 655,
   0,   0,  43,   0, 459,  43, 141, 139, 138, 141,
 142, 138,   0, 142,   0,   0,   0, 463,  44,  45,
  46,  44,  45,  46,   0,   0,   0,   0,   0, 141,
  43,   0, 459, 142, 141,   0, 138, 141, 142,   0,
   0, 142,   0,   0,   0,   0,  44,  45,  46,   0,
  43,   0, 139,   0,   0,   0, 138,   0,   0,   0,
   0,   0,   0,   0,   0,   0,  44,  45,  46,   0,
  43,   0, 139,   0,   0,  43, 138, 139,   0,   0,
   0, 138, 679,   0,   0,   0,  44,  45,  46,   0,
   0,  44,  45,  46,   0,   0,  43,   0, 139,   0,
   0,   0, 138,  43,   0, 139,   0,   0,   0, 138,
   0,   0,  44,  45,  46, 463,   0,   0,   0,  44,
  45,  46, 563,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  43,   0, 139,   0,   0,   0, 138,   0,  43,   0,
 139,   0,   0,  43, 138, 139,  44,  45,  46, 138,
 681,   0,   0,   0,  44,  45,  46,   0,   0,  44,
  45,  46,   0,  43,   0, 139,   0,   0,   0, 138,
  43,   0, 139,   0,   0,   0, 138,   0,   0,  44,
  45,  46,   0,   0,   0,   0,  44,  45,  46,   0,
   0,   0,  43,   0, 139,  43,   0, 139, 138,   0,
   0, 138,   0,   0, 474,   0,   0, 290,  44,  45,
  46,  44,  45,  46,   0,  43,   0, 139,   0,   0,
  43, 138, 139,  43,   0, 139, 138, 283,   0, 138,
   0,  44,  45,  46,   0,   0,  44,  45,  46,  44,
  45,  46 };
short yypact[]={

 -22,-1000,1873,-232,-1000, -78,-1000,-1000,-143,-1000,
 163, 163,-1000,2330,1873, 180,2387,-1000,-1000, 172,
2794, 170,1873, 177, 338,2387,-1000,-1000,-1000, 179,
-1000,-1000,-1000,-1000,1606,-1000,1812,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,  -2, -69,
-1000, 170,2896, 177,2283,-1000,-1000,-1000,-1000,-1000,
-146,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
2214,-1000,-1000, -27,2148, 172, 182,2787,-1000,-1000,
 335,-1000,2558,-1000, 176,-1000,-1000,-1000,1294,2794,
 -49,-1000, -48, -47,-1000,2387, 172, 182, 787, 759,
 474, 163,2078,2078,-1000, 752, 723, 706,2181, 692,
 675, 622, 654, 648,-1000,-1000, 357, 278,-1000,  56,
 501,1509,-1000, 767,-1000,-1000,-1000,-1000,-216,-1000,
2846,3148,-1000,-1000,-1000,  22,3128,-1000,-1000,-1000,
-1000, 976,-1000,-1000,2330,-1000,-1000, 232, 230, 218,
 217,2330,-1000,-1000, 175, 142, 387,-1000,-195, 170,
 143, 500,-1000,-1000, 368,1277,1873,-1000,2794, 731,
 727, 740, 384, 723, 706,2419, 692, 675, 654, 648,
-166, 122, 496,-1000,   9,-1000, 348,   9,   9,2794,
-1000,2794, 182, 361,-1000,-1000,-1000,2646,-1000,1873,
2535, 356,1873,1873, 155, 194, 172, 131,-1000,1873,
-1000,1873,-1000,1873,-177,1999, 647,-1000, 642,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,1873,
-1000,1873,1943,1873, 142,-1000, 376,-1000, 375,-1000,
-1000,-1000,-191, -87,1369,1326, -46, 801, 963, 758,
 234,-1000,  93, 227, -51, -52, -80, 105,-1000,2794,
-1000,2354,1838,1838,1838,2490, -54,1146,2099,-1000,
2928, 713, 629, 637, 623, 614, 602,-1000,3125,-1000,
-1000,-1000,2826,2099,-1000,-1000,-1000,-1000,-177,2099,
2099,-1000, 219,-1000,-1000,3026,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,2466,-1000,-1000,-1000,2148,1873,
 -49,-1000, 182,1873, 633, 622,-1000,-1000,-1000,-1000,
-1000,2466,-1000,2466,-177,-1000,-1000,2794,-1000,2099,
-119,2758, -99,2466,2722,2466,2695,2670,-1000,-1000,
 130, 487,-1000, 366,-1000,-1000,2466,-1000,-1000,-1000,
-1000,-1000,-1000, -35,-1000,-1000,-1000,-1000, 358, 483,
-1000,-1000,-1000,-1000,-1000, 604,-1000, 357,-1000,-1000,
-1000,-1000,-196, 486,-1000,-201, 170,-1000,-1000,-1000,
-236,1744,  82, -88,-1000,-1000,-1000, 934,-1000,-1000,
3103,-221,-1000, 216,  22,3096,-222,-1000,-1000,-1000,
  96,-1000,-1000,-123, -78,-1000,-226,3153, -78,-1000,
-227,3153,2099,-1000,-1000,2099, -78,-1000,1873, 154,
-1000,2078,-1000,1488,-1000,-1000,1488,-1000,1488,-1000,
3076, 970,-1000,2466,2622,-1000,-1000,-1000,-112,2466,
-1000,-1000,-1000,2466,2466, 596,2588, 579,2354, 162,
-1000, 587,-1000,-1000,-1000, 761, -88,1425,-1000,-1000,
-1000,-1000,2099,2099,-1000,2099,-1000,-121,-1000,-1000,
2099,-1000,-1000,2099,2099,-1000,-1000,1545, 515, 276,
-1000,-167,-1000,-1000,-1000,-1000,-1000, 142, 363,-1000,
 -56,-1000,-1000,-1000,-1000,-1000, 578,-1000, 348,-1000,
-1000,-1000,2794,-1000,-1000,2794,-1000,-1000,2794,-1000,
2794,-1000, 182,2466,-1000,1873,1873,-1000,1873,1943,
1873, -49,1674,-1000,-1000,-1000,-1000, -88, 754,  42,
  31,2099,-1000,2925,-100,-1000,2973, 511,2925,-100,
2046, 970,-1000,-1000,-154,-1000,-154, 570, 473,-1000,
 227,-1000,-1000,-1000, 345, 468,-1000,-1000,-1000,-197,
 468, 468,-1000,-1000,-228,-1000,2043,2993,-210,3071,
-1000,-1000,-1000, 115,-1000,   9, 115,-1000,-1000,-1000,
-1000,2794,2794,2794,1509,-1000, 680,1214,-1000,-1000,
3026,-1000,-1000,-1000,3026,-1000,3153,-1000,-1000,-1000,
-1000,-1000,2099,-1000,2099,-1000,2099,-177,2099,-1000,
2466, -78, 149,1873,-1000,-1000,2078,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
  53,  42, 569,-1000, 432,-1000,-1000, 747, -88,-1000,
 -55, 120,-1000,-177,-1000,-230,-1000,  79,1441,3153,
 891, 102,3063,3019, 158,-1000, 806,-1000,-1000,-121,
-1000,-121, -76,-1000,  19,-1000,-1000,3153,3153,-1000,
2099,-1000,1873,1488,3156, 558,-177,-1000,1517,3156,
3156,3156,-1000,-1000,-1000, 142,-1000,-1000, 553, 551,
-1000, 418,-1000,-1000,-1000, 549,-1000,-167,-1000,-1000,
-1000,-1000,-1000,-214,-1000, 541,-1000, 652,1124,  53,
 970,-1000,2925, 104, 542,-1000,2953,2998,3153,-1000,
-138, 102,3153,3153,2998,2998,3153,-1000,-1000,-1000,
-1000,3153, 795,2925,3153,3153,-1000,2925,-1000,-1000,
-1000,-1000,2993,1517,-1000, 539,-1000,-1000,-1000,-1000,
-1000,-1000, 735,-1000,1873,-1000,-1000, 534, 533,-1000,
 417,-1000,-1000,-1000,1620,-1000, 413,-1000,-192,-1000,
-1000,-154,  76,-177,-1000,1441,  55,-1000,3153,-1000,
-1000,-1000,2998,-1000,-1000,-1000,-1000, 248,-1000,-1000,
  74,-1000, 120, -76,2896,-1000,-1000,-1000,-1000, 246,
 970,2046, 524, 403,-1000,-1000,-1000,-1000,-1000,-1000,
 970,2819,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-154,
-1000,-1000,-1000,2099,-1000,-1000 };
short yypgo[]={

   0, 992,1312,  75, 991, 990, 989,  42,  23, 980,
 979,  20,  50, 978,  56, 977,  31,  14,1174, 426,
 976, 972,  12,  51,  45,  24, 970,  34, 424, 965,
 964,  10,  32, 961,  48,  62,  37,  25, 959, 580,
  16,  52,   2,  13,   0,   8,   6,  15,  26,   9,
  22,  11, 277,   5, 102, 569, 958, 949, 944, 138,
   3,   7,   1, 943, 942, 936,  36, 934, 932, 925,
 923,  18, 922,   4, 921,  54, 482, 917, 357,  60,
 915, 763, 173, 227, 914, 912,  27, 908, 241,  43,
  17,  63, 906, 903, 902,  33, 465, 272, 270,  38,
  41, 260,  39, 901, 898, 862, 896, 894,  47,  30,
  28, 238,  44, 581,  76, 953,1131,1419, 893, 892,
 891, 889, 888,  40,  49,  77,  21, 456, 887, 885,
2100, 884,2108, 494, 882, 881, 880, 878, 589, 338,
 842, 877, 874, 816, 276, 872,  19, 866, 860,  29,
 852,  67, 850,  64, 844, 833, 827, 821,  59,  46,
 811, 780 };
short yyr1[]={

   0,   1,   1,   1,   4,   4,   4,   5,   9,  11,
  11,   7,   7,   7,  10,  10,  10,  10,  15,  15,
  16,  16,  16,  16,  16,  20,  20,  20,  20,  21,
  21,  22,  22,  13,  13,  14,  23,  23,  23,  23,
  23,  24,  24,  24,  25,  25,  25,  25,  26,  26,
  27,  27,  27,  27,  29,  29,  29,  29,  30,  30,
  31,  31,  12,  12,  12,  12,  33,  33,  33,  33,
  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,
  34,  34,  34,  36,  36,  36,  38,  38,  45,  45,
  40,  40,  47,  47,  49,  49,  50,  50,  50,  50,
  50,  50,  50,  50,  50,  50,  56,  56,  56,  57,
  57,  57,  57,  57,  53,  53,  53,  43,  58,  58,
  60,  60,  60,  41,  41,  41,  63,  63,  64,  64,
  34,  65,  65,  65,  66,  66,  34,  34,  34,  34,
  34,  34,  67,  67,  68,  68,  69,  69,  70,  70,
  46,  46,  71,  71,  71,  71,  62,  62,  55,  48,
  48,  73,  73,  42,  42,  42,  42,  42,  42,  76,
  76,  77,  77,  77,  77,  77,  37,  37,  78,  78,
  78,  78,  74,  74,  80,  80,  80,  80,  51,  51,
  79,  79,  39,  39,  59,  59,  72,  72,  54,  54,
  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,
  82,  81,  81,  81,  75,  75,  84,  84,  84,  84,
  85,  85,  86,  87,  87,  87,  87,  87,  87,  87,
  87,  88,  88,  89,  89,  61,  61,  91,  91,  92,
  92,  92,  93,  35,  35,  35,  35,  94,  94,  94,
  97,  97,  97,  97,  97,  98,  98,  98,  98,  98,
  95,  95, 106, 106, 107, 107, 108,   3,   3, 110,
 110, 111, 111,  99,  96,  96,  96, 104, 104, 112,
 112, 102, 102, 102, 102, 102, 102, 102, 102, 102,
 102, 113, 113, 100, 100, 115, 115, 105, 105, 105,
 116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
 116, 116, 116, 119, 119, 120, 120, 118, 118, 122,
 122, 123, 123, 121, 121, 124,   2,   2, 125, 125,
 125, 109, 109, 126, 126, 128, 128, 129, 129, 129,
 129, 129, 131, 131, 131, 131, 131, 130, 130, 130,
 132, 132, 132, 132, 137, 137, 136, 136, 138, 138,
 138, 138, 138, 138, 138, 138, 138, 138, 138, 138,
 138, 138, 138, 138, 138, 138, 138, 138, 138, 140,
 140, 141, 141, 144, 134, 134, 145, 145, 146, 147,
 147, 147, 148, 148, 149, 135, 135, 150, 150, 151,
 151, 151, 139, 139, 152, 152, 153, 153, 127, 127,
 154, 154, 154, 155, 156, 156, 142, 142, 142, 142,
 142, 142, 142, 157, 157, 158, 158, 158, 117, 117,
 117, 117,  83,  83,  44,  44,  44,  44,  19,  19,
  28,  28,  28,  28,  28,  28,  17,  17,  17,  32,
  32,  18,  18,  18, 101, 101, 101, 160, 160, 103,
 103, 159, 159, 159, 159, 161, 161, 143, 143, 143,
  52,  52, 114, 114, 114,  90,  90, 133, 133,   6,
   8,   8 };
short yyr2[]={

   0,   3,   2,   1,   4,   7,   2,   0,   1,   1,
   1,   1,   2,   4,   0,   2,   3,   4,   3,   1,
   1,   1,   4,   4,   2,   0,   1,   1,   2,   3,
   1,   1,   1,   3,   1,   0,   3,   5,   6,   4,
   2,   0,   4,   3,   0,   1,   1,   2,   3,   1,
   1,   1,   4,   4,   0,   1,   1,   2,   3,   1,
   1,   1,   0,   1,   1,   2,   3,   3,   1,   1,
   4,   6,   2,   5,   7,   2,   4,   2,   5,   7,
   2,   2,   2,   2,   1,   1,   3,   1,   3,   1,
   3,   1,   4,   1,   3,   1,   4,   3,   3,   3,
   1,   1,   1,   4,   3,   1,   3,   3,   2,   2,
   2,   2,   2,   3,   2,   1,   1,   1,   3,   1,
   3,   3,   4,   0,   2,   4,   0,   1,   3,   1,
   4,   3,   1,   1,   2,   1,   3,   3,   4,   2,
   2,   2,   3,   1,   3,   1,   0,   1,   3,   1,
   3,   1,   3,   3,   3,   1,   4,   1,   3,   3,
   1,   3,   1,   2,   1,   3,   3,   1,   3,   3,
   3,   3,   3,   3,   3,   1,   1,   1,   1,   3,
   3,   1,   1,   1,   1,   3,   3,   1,   1,   1,
   2,   1,   2,   1,   1,   1,   1,   1,   2,   1,
   1,   2,   3,   3,   3,   3,   3,   3,   3,   2,
   1,   1,   3,   5,   3,   3,   3,   3,   3,   3,
   3,   1,   3,   3,   2,   3,   2,   3,   2,   3,
   3,   1,   0,   3,   1,   3,   1,   3,   3,   0,
   2,   2,   2,   1,   2,   4,   2,   1,   1,   1,
   3,   3,   3,   3,   3,   4,   4,   4,   2,   2,
   2,   1,   2,   1,   2,   1,   4,   0,   2,   1,
   1,   3,   1,   3,   1,   1,   1,   1,   1,   1,
   1,   2,   2,   3,   4,   3,   4,   3,   4,   3,
   4,   1,   1,   1,   1,   2,   2,   1,   1,   1,
   3,   1,   4,   1,   1,   1,   3,   3,   3,   3,
   2,   3,   5,   3,   3,   3,   1,   0,   1,   3,
   1,   3,   1,   3,   1,   3,   1,   1,   3,   3,
   1,   1,   1,   1,   1,   1,   1,   4,   3,   2,
   4,   3,   4,   3,   2,   4,   3,   6,   4,   1,
   4,   4,   6,   4,   2,   1,   2,   1,   1,   3,
   2,   1,   1,   1,   4,   4,   1,   1,   1,   1,
   3,   3,   3,   5,   1,   3,   4,   4,   4,   3,
   3,   3,   1,   3,   1,   2,   3,   1,   3,   1,
   2,   1,   2,   1,   4,   2,   1,   3,   1,   3,
   2,   1,   0,   1,   3,   1,   1,   3,   3,   3,
   0,   2,   2,   2,   3,   1,   1,   1,   3,   3,
   4,   2,   5,   3,   1,   3,   1,   2,   1,   2,
   2,   3,   2,   1,   1,   1,   1,   1,   1,   1,
   1,   3,   3,   3,   3,   3,   1,   3,   1,   1,
   3,   1,   3,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   3,   1,   1,   1,   1,   1,   3,   1,
   1,   3,   1,   3,   1,   1,   1,   1,   1,   1,
   1,   1 };
short yychk[]={

-1000,  -1, 257, 258, 256,  -2,-125, 256,-126,-109,
-129,-130,-128,  45, 259, 276,-136,-131,-132,-138,
  92, 267, 263, 280, -17, 126, 295,  95,-117, -18,
 283, 284, 285, 281,  40, 294,  91, 291, -28, 293,
 -32, -44, 289, 287, 303, 304, 305,  -4,  -5, 301,
  -3, 266, 296, 279,-133,-161,-114,  45,-143, 292,
  96, -52, 290,-160, 288,  43,-159, 286,  33,  46,
-133,-130,-132,  -2, 123,-138, 123,-137,-105, 283,
 -28,-116,  40,-117, -18, 284, 285,  95,  91, 126,
 -91, 123,  -2,-127, 123,  64,-138, 123,  -2,-140,
-141,-130,-143,-114,  41, -83, 286,  43,  45,  33,
  46, 290, 288, 292,-144,  44, -44,-142,  93,  -2,
-140,  -6, 256,  -9, 256, 289, -91, -73, -42, -74,
  40, -39, -76, -80, -19, -44, -54, 256, 293, 289,
 -82,  91,  95,-127,  45,-130,-132, -44, 291, 289,
 293,  45,-130,-132, 260,-135,-150,-151,-125, 267,
-139,-152,-153, -28, -17,  40, 299,-105,  64,-111,
 -99,-119,-121, 286,  43,  45,  33,  46, 288, 292,
 -96, -28,-110,-124, 283,-112, -44,-100,-102,-115,
-116,-117, 123,-120,-110, -99,-111,  45,-105, 268,
 -92, -93, 264, 268,-154,-155,-138,-139,  41,  44,
  41,  44,  41, 124,  44,-133,-109,-126,-109,  41,
  44,  41,  41,  41,  41,  41,  41,  41,  41,  61,
  93,  44, 124, 297,  -7, -12, -13,  59, -33, -23,
 -34, -35, 302, 262, 261, 273, 306, 272, 277, 278,
 274, -87, -94, -96, 269, 270, 271, -61, -97, -98,
 -99, -28, 283,-100,-102,  40, -10,  40, 300,  41,
 -39, -75, -77, 299, -78, -83, -84, -76, -79, 256,
 -81, -82,  40, 299, -59, -81, -19, -44,  92, 296,
 299, -59, -37,  93, -78, -39,-130,-132,  96,  96,
  96,  96,-130,-132, 123,  -8, 125, 256,  59, 298,
 -91, 125,  44,  61,  45, 290,  -2,-105,  41,  41,
  41,  44,  41, 124,  44,-113, 256,-115,-105, 296,
  43,-114,  96,  44,-114,  61,-114,-114,-105,-105,
-118,-122,-123, -17, -28,  93,  44,  -2,  -8,  59,
 -35,  -8,  59,  -2,  -2,  -8,  59,-156, -28,  40,
  -8,  59, 125,  -2,  -2,  -2,-144, -44,  41,  41,
  41,  -2,  -2,-157,-158,  -2, 267,  -2,  -8, -14,
  59,  59, -11, 304, 256, 289, 285, -36, 256, 289,
 -39, -42, 256,  40, -44, -39, -42, 256, 283, 256,
 -65, -66, 256, -28, -67, 256, -42, -39, -68, 256,
 -42, -39,  40, 256, -95, 296,-106, 256,  61,-107,
-108, 124, -95, -88, 256, 283, -88, 256, -88, 256,
 296,  44,-105,-103,  43,-105,  45,-159,  96,-101,
  43,  45,-159,-101,-101, -97, -98, -99, -28, 266,
  41, -15, -16, -17, -18, -19, 301,  40, 293, 289,
 -37,  41,  44, 299,  41,  44,  41,  44,  41,  41,
  44,  41,  41,  44, 299, -59,  41, -39, -75, -85,
 -86, -44, -37, -44, -37, -37,  93,-134,-145,-146,
-110,-151,  -2,-153,  -2,-110,-110,-124, -44, -37,
 283,-113,  45,-110,-113,  45,-110,-113,  45,-113,
  45, 125,  44,  61,-110, 265,  61,  41, 297,  44,
 298, -91, -14, -23, -34, -35, -24, 305, 303,  40,
 -11,  61, -44,  61, 300,  41, -39, -75,  61, 300,
 296,  44, 285,  -3, 300,  -3, 300, -69, -70, -37,
 -37,  -3,  -2,-108,-109, -89, -90,-101, -52,  96,
 -89, -89, -46, 256, -42, -71,  40, -39, -55, -54,
 -72, -28, -96, -28,-104, 283, -28,-112, -96, -96,
 -96,  41,  41,  41, 123,  41,  44,  40, -11, -76,
 -39, -78, -37, -76, -39, -78, -39, -76, -37, -37,
 -37,  41,  44,  41,  44,  41, 124,  44, 296,  -8,
  59,-147,-148, 299, 256,-149, 124,  41,-113,-113,
-113,-113,-123,-110,  -2,  -2,  -2,-158,  -2, -12,
 -11,  40, -25,  44, -26, -27, -28, 289, 305, -24,
 -37, -40, -47, 282, -49, -42, -50,  40, -39,  33,
 -54, -55, -56, -57, -32, 256, -36, 256,  41,  44,
  41,  44, -43, -47, -36, -46, -66, -39, -39,  41,
  44, -95,  61,  44, 300, -62, 282, -55,  40, 299,
 299, 299,-105,-105,-105,  -7,  41, -16, 297, -20,
  44, -21, -22, -17, -18, -37, -86, -44, -37,-146,
  -3,-149,  -2,-109, -24, -25,  41,  44,  40, -11,
 268, -41, 124, 275, -48, -44, 300, -52,  33, -55,
  96, -51, -79, -39, -52, -52,  33, -59, -55, -55,
 -59,  33, 123,  61, -39, -39, -41,  61, -37,  -2,
 -90, -71, -39,  40,  41, -48, -71, -71, -71,  -8,
  41,  41,  44,  41, 299,  41, -27, 297, -29,  44,
 -30, -31, -28, -32,  40, -24, -38, -45, -28, -47,
 -19,  40,  46,  44, -50, -39,  40, -53,  33, -51,
 -55, -59, -52, -53, -53, -59, -59, -58, 125, -60,
 -61, -28, -40, -43,  46, -22,  -2,  41,  41,  44,
  44, 296, -63, -64, -19, -49, -44, -51, -53, 125,
  44, 296, -41, -41, -73, -31, -45, -46,  41,  44,
 -60, -62, -37,  33, -19, -37 };
short yydef[]={

   0,  -2,   0,   7,   3, 267, 326, 327, 331, 330,
 333, 334, 332,   0,   0,   0, 349, 335, 336, 357,
   0,   0,   0,   0, 358,   0, 361, 362, 363, 428,
 366, 367, 368, 369,   0, 374,   0, 446, 448, 451,
 453, 440, 449, 434, 435, 436, 437,   2,   0,   0,
   1,   0,   0,   0,   0, 477, 478, 465, 466, 472,
   0, 474, 467, 469, 470, 457, 458, 461, 463, 464,
   0, 339, 344,   0,   0, 356, 402,   0, 355, 297,
 298, 299,   0, 301, 428, 303, 304, 305,   0,   0,
   0, 239,   0,   0, 410,   0, 360, 402,   0,   0,
   0, 334,   0,   0, 429,   0, 461, 457,   0, 463,
 464, 467, 470, 472, 382, 433, 440,   0, 430, 416,
 417,  62, 479,  14,   6,   8, 268, 328,   0, 162,
   0,  -2, 167, 182, 193, 200, 184, 187, 438, 439,
 199,   0, 210, 329,   0, 338, 343,   0,   0,   0,
   0,   0, 341, 346,   0,   0, 396, 398, 401,   0,
   0, 403, 405,  -2,   0,   0,   0, 354,   0, 270,
 269,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 272, 274,   0, 324, 275, 276, 440, 279, 280, 293,
 294, 301, 317,   0, 316, 269, 270,   0, 310,   0,
   0,   0,   0,   0,   0,   0, 359,   0, 370,   0,
 371,   0, 372,   0,   0,   0,   0, 331,   0, 431,
 432, 441, 442, 443, 444, 445, 447, 450, 452,   0,
 375,   0,   0, 421,   0,  11,  35,  63,  64,  34,
  68,  69,   0,   0,   0,   0,   0,   0,   0,   0,
   0, 243,   0,   0, 232, 232, 232,   0, 247, 248,
 249,  -2, 275, 279, 280,   0,   0,   0,   0,  -2,
   0,   0,   0,   0,   0,   0,   0, 175, 178, 181,
 191, 211,   0,   0, 192, 194, 195, 200,   0,   0,
   0, 198,   0, 209, 176, 177, 337, 342, 462, 468,
 471, 473, 340, 345,   0, 348, 480, 481, 395,   0,
 400, 365,   0,   0,   0,   0, 350, 300, 306, 307,
 308,   0, 311,   0,   0, 281, 282, 291, 292,   0,
   0,   0,   0,   0,   0,   0,   0,   0, 295, 296,
   0, 318, 320,   0,  -2, 309,   0, 351, 237, 240,
 242, 238, 241,   0, 353, 408, 411, 413, 415,   0,
 409, 412, 364, 380, 379,   0, 381,   0, 376, 377,
 378, 383, 380, 418, 424, 426,   0, 419,   4,  12,
  35,  65,  41,   0,  40,   9,  10,   0,  -2,  84,
  -2,   0,  77,   0,   0, 164,   0,  80,  81,  82,
   0, 132, 133, 135, 267, 139,   0,  -2, 267, 140,
   0,  -2, 146, 141, 244,   0, 267, 261,   0, 263,
 265,   0, 246,   0, 224, 231,   0, 226,   0, 228,
   0,   0, 259,   0,   0, 258, 459, 460,   0,   0,
 454, 455, 456,   0,   0,   0,   0, 269, 274,   0,
  15,   0,  19,  20,  21,   0,   0,   0,  -2,  -2,
 161,  -2,   0,   0,  -2,   0, 168,   0, 202, 203,
   0, 205, 207,   0,   0, 190, 201,   0,   0,   0,
 221, 200, 186, 169, 170, 185, 208,   0, 384, 387,
   0, 397, 399, 404, 407, 313,   0, 323,   0, 271,
 273, 283,   0, 314, 285,   0, 325, 287,   0, 289,
   0, 302,   0,   0, 315,   0,   0, 373, 420,   0,
   0, 427,  62,  33,  66,  67,  36,   0,   0,  44,
  41,   0,  83,   0,   0, 163,   0,   0,   0,   0,
   0,   0, 134, 136,   0, 137,   0,   0, 147, 149,
   0, 260, 262, 264,   0, 223, 234, 475, 476,   0,
 225, 227, 229, 230,   0, 151,   0,  -2,   0, 196,
 155, 235, 253, 274, 254, 273, 277, 278, 252, 250,
 251,   0,   0, 307,  62,  16,   0,  25,  24, 174,
 215, 217, 180, 171, 214, 218, 172, 173, 216, 219,
 179, 204,   0, 206,   0, 212,   0,   0,   0, 347,
 385, 267, 389,   0, 391, 393,   0, 312, 284, 286,
 288, 290, 319, 321, 352, 414, 422, 423, 425,  13,
  41,  44,   0,  45,  46,  49,  50,  51,   0,  39,
  70, 123,  91,   0,  93,   0,  95,   0,  -2,   0,
   0,   0, 101, 102,   0, 105,  76,  85, 165,   0,
 166,   0, 123, 117,   0, 130, 131, 142, 144, 138,
   0, 245,   0,   0,   0,   0,   0, 157,   0,   0,
   0,   0, 255, 256, 257,   0,  17,  18,   0,   0,
  26,  27,  30,  31,  32,   0, 220,   0, 222, 386,
 388, 392, 390,   0,  37,   0,  43,  47,  54,  41,
   0,  73,   0,   0,   0, 160,   0,   0,   0, 109,
   0,   0, 188, 189,   0,   0,   0, 108, 110, 111,
 112,   0,   0,   0, 215, 214,  78,   0, 148, 266,
 233, 150, 197,   0, 158,   0, 154, 152, 153,   5,
  22,  23,  28, 213,   0,  42,  48,   0,   0,  55,
  56,  59,  60,  61,   0,  38,  71,  87,  89,  90,
 124, 126,   0,   0,  94, 100,   0,  98,   0, 115,
 116, 106,   0,  97,  99, 107, 113,   0, 104, 119,
   0, 236, 123, 123,   0,  29, 394,  52,  53,  57,
   0,   0,   0, 127, 129,  92, 159, 114,  96, 103,
   0,   0,  74,  79, 156,  58,  86,  88, 125,   0,
 118, 120, 121,   0, 128, 122 };
#define YYFLAG   -1000
#define YYERROR  goto yyerrlab
#define YYACCEPT return(0)
#define YYABORT  return(1)

/*      parser for yacc output  */

#ifdef YYDEBUG
int yydebug     = 0;     /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar      = -1;    /* current input token number */
int yynerrs     = 0;     /* number of errors */
short yyerrflag = 0;     /* error recovery flag */

int yyparse() {
    short yys[YYMAXDEPTH];
    short yyj, yym;
    register YYSTYPE *yypvt;
    register short yystate, *yyps, yyn;
    register YYSTYPE *yypv;
    register short *yyxi;

    yystate   = 0;
    yychar    = -1;
    yynerrs   = 0;
    yyerrflag = 0;
    yyps      = &yys[-1];
    yypv      = &yyv[-1];

yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
    if (yydebug)
        printf("state %d, char 0%o\n", yystate, yychar);
#endif
    if(++yyps>&yys[YYMAXDEPTH]) {
        yyerror("yacc stack overflow");
        return(1);
    }
    *yyps = yystate;
    ++yypv;
#ifdef UNION
    yyunion(yypv, &yyval);
#else
    *yypv = yyval;
#endif

yynewstate:

    yyn = yypact[yystate];

    if (yyn<=YYFLAG)
        goto yydefault; /* simple state */

    if (yychar<0)
        if ((yychar=yylex())<0)
            yychar=0;
    if ((yyn+=yychar)<0 || yyn>=YYLAST)
        goto yydefault;

    if (yychk[yyn=yyact[yyn]]==yychar) {
        /* valid shift */
        yychar = -1;
#ifdef UNION
        yyunion(&yyval, &yylval);
#else
        yyval = yylval;
#endif
        yystate = yyn;
        if (yyerrflag>0)
            --yyerrflag;
        goto yystack;

    }

yydefault:

    /* default state action */

    if ((yyn=yydef[yystate])== -2) {
        if (yychar<0)
            if ((yychar=yylex())<0)
                yychar = 0;
        /* look through exception table */

        for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2)
            ; /* VOID */

        for (yyxi+=2; *yyxi >= 0; yyxi+=2) {
            if (*yyxi==yychar)
                break;
        }
        if ((yyn=yyxi[1])<0)
            return(0);   /* accept */
    }

    if (yyn==0) {
        /* error */
        /* error ... attempt to resume parsing */

        switch (yyerrflag) {
            case 0: /* brand new error */
                    yyerror( "syntax error" );

yyerrlab:           ++yynerrs;

            case 1:
            case 2: /* incompletely recovered error ... try again */

                    yyerrflag = 3;

                    /* find a state where "error" is a legal shift action */

                    while (yyps>=yys) {
                        yyn = yypact[*yyps] + YYERRCODE;
                        if (yyn>=0 && yyn<YYLAST
                                   && yychk[yyact[yyn]]==YYERRCODE) {
                            yystate = yyact[yyn];
                            /* simulate a shift of "error" */
                            goto yystack;
                        }
                        yyn = yypact[*yyps];

                        /* the current yyps has no shift on "error",
                           pop stack */

#ifdef YYDEBUG
                        if (yydebug)
                            printf("error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1]);
#endif

                        --yyps;
                        --yypv;
                    }

                    /* there is no state on the stack with an error shift
                       ... abort */

yyabort:            return(1);


            case 3: /* no shift yet; clobber input char */
#ifdef YYDEBUG
                    if (yydebug)
                        printf("error recovery discards char %d\n", yychar);
#endif

                    if (yychar==0)
                        goto yyabort; /* don't discard EOF, quit */
                    yychar = -1;
                    goto yynewstate;   /* try again in the same state */
        }
    }

    /* reduction by production yyn */

#ifdef YYDEBUG
    if (yydebug)
        printf("reduce %d\n",yyn);
#endif
    yyps -= yyr2[yyn];
    yypvt = yypv;
    yypv -= yyr2[yyn];
#ifdef UNION
    yyunion(&yyval, &yypv[1]);
#else
    yyval = yypv[1];
#endif
    yym=yyn;
    /* consult goto table to find next state */
    yyn = yyr1[yyn];
    yyj = yypgo[yyn] + *yyps + 1;
    if (yyj>=YYLAST || yychk[yystate=yyact[yyj]]!= -yyn)
        yystate = yyact[yypgo[yyn]];
    switch(yym) {
        
case 1:
# line 104
{inputExpr = letrec(yypvt[-0],yypvt[-1]); sp-=2;} break;
case 2:
# line 105
{valDefns  = yypvt[-0];	    sp-=1;} break;
case 3:
# line 106
{syntaxError("input");} break;
case 4:
# line 119
{
					 setExportList(singleton(ap(MODULEENT,mkCon(module(currentModule).text))));
					 yyval = gc3(yypvt[-1]);
					} break;
case 5:
# line 124
{setExportList(yypvt[-4]);   yyval = gc7(yypvt[-1]);} break;
case 6:
# line 125
{syntaxError("module definition");} break;
case 7:
# line 131
{startModule(conMain); 
					 yyval = gc0(NIL);} break;
case 8:
# line 134
{startModule(yypvt[-0]); yyval = gc1(NIL);} break;
case 9:
# line 136
{yyval = yypvt[-0];} break;
case 10:
# line 137
{ extern String scriptFile;
					  String modName = findPathname(scriptFile,textToStr(textOf(yypvt[-0])));
					  if (modName) { /* fillin pathname if known */
					      yyval = mkStr(findText(modName));
					  } else {
					      yyval = yypvt[-0];
					  }
					} break;
case 11:
# line 146
{yyval = yypvt[-0];} break;
case 12:
# line 147
{yyval = gc2(NIL);} break;
case 13:
# line 148
{yyval = gc4(yypvt[-0]);} break;
case 14:
# line 153
{yyval = gc0(exportSelf());} break;
case 15:
# line 154
{yyval = gc2(NIL);} break;
case 16:
# line 155
{yyval = gc3(yypvt[-1]);} break;
case 17:
# line 156
{yyval = gc4(yypvt[-2]);} break;
case 18:
# line 158
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 19:
# line 159
{yyval = gc1(singleton(yypvt[-0]));} break;
case 20:
# line 164
{yyval = yypvt[-0];} break;
case 21:
# line 165
{yyval = yypvt[-0];} break;
case 22:
# line 166
{yyval = gc4(pair(yypvt[-3],DOTDOT));} break;
case 23:
# line 167
{yyval = gc4(pair(yypvt[-3],yypvt[-1]));} break;
case 24:
# line 168
{yyval = gc2(ap(MODULEENT,yypvt[-0]));} break;
case 25:
# line 170
{yyval = gc0(NIL);} break;
case 26:
# line 171
{yyval = gc1(NIL);} break;
case 27:
# line 172
{yyval = yypvt[-0];} break;
case 28:
# line 173
{yyval = gc2(yypvt[-1]);} break;
case 29:
# line 175
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 30:
# line 176
{yyval = gc1(singleton(yypvt[-0]));} break;
case 31:
# line 178
{yyval = yypvt[-0];} break;
case 32:
# line 179
{yyval = yypvt[-0];} break;
case 33:
# line 184
{imps = cons(yypvt[-0],imps); yyval=gc3(NIL);} break;
case 34:
# line 185
{imps = singleton(yypvt[-0]); yyval=gc1(NIL);} break;
case 35:
# line 187
{if (chase(imps)) {
					     clearStack();
					     onto(imps);
					     done();
					     closeAnyInput();
					     return 0;
					 }
					 yyval = gc0(NIL);
					} break;
case 36:
# line 198
{addQualImport(yypvt[-1],yypvt[-1]);
					 addUnqualImport(yypvt[-1],yypvt[-0]);
					 yyval = gc3(yypvt[-1]);} break;
case 37:
# line 202
{addQualImport(yypvt[-3],yypvt[-1]);
					 addUnqualImport(yypvt[-3],yypvt[-0]);
					 yyval = gc5(yypvt[-3]);} break;
case 38:
# line 206
{addQualImport(yypvt[-3],yypvt[-1]);
					 yyval = gc6(yypvt[-3]);} break;
case 39:
# line 209
{addQualImport(yypvt[-1],yypvt[-1]);
					 yyval = gc4(yypvt[-1]);} break;
case 40:
# line 211
{syntaxError("import declaration");} break;
case 41:
# line 213
{yyval = gc0(DOTDOT);} break;
case 42:
# line 214
{yyval = gc4(ap(HIDDEN,yypvt[-1]));} break;
case 43:
# line 215
{yyval = gc3(yypvt[-1]);} break;
case 44:
# line 217
{yyval = gc0(NIL);} break;
case 45:
# line 218
{yyval = gc1(NIL);} break;
case 46:
# line 219
{yyval = yypvt[-0];} break;
case 47:
# line 220
{yyval = gc2(yypvt[-1]);} break;
case 48:
# line 222
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 49:
# line 223
{yyval = gc1(singleton(yypvt[-0]));} break;
case 50:
# line 225
{yyval = yypvt[-0];} break;
case 51:
# line 226
{yyval = yypvt[-0];} break;
case 52:
# line 227
{yyval = gc4(pair(yypvt[-3],DOTDOT));} break;
case 53:
# line 228
{yyval = gc4(pair(yypvt[-3],yypvt[-1]));} break;
case 54:
# line 230
{yyval = gc0(NIL);} break;
case 55:
# line 231
{yyval = gc1(NIL);} break;
case 56:
# line 232
{yyval = yypvt[-0];} break;
case 57:
# line 233
{yyval = gc2(yypvt[-1]);} break;
case 58:
# line 235
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 59:
# line 236
{yyval = gc1(singleton(yypvt[-0]));} break;
case 60:
# line 238
{yyval = yypvt[-0];} break;
case 61:
# line 239
{yyval = yypvt[-0];} break;
case 62:
# line 244
{yyval = gc0(NIL);} break;
case 63:
# line 245
{yyval = gc1(NIL);} break;
case 64:
# line 246
{yyval = yypvt[-0];} break;
case 65:
# line 247
{yyval = gc2(yypvt[-1]);} break;
case 66:
# line 249
{yyval = gc2(yypvt[-2]);} break;
case 67:
# line 250
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 68:
# line 251
{yyval = gc0(NIL);} break;
case 69:
# line 252
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 70:
# line 257
{defTycon(4,yypvt[-1],yypvt[-2],yypvt[-0],SYNONYM);} break;
case 71:
# line 259
{defTycon(6,yypvt[-3],yypvt[-4],
						    ap(yypvt[-2],yypvt[-0]),RESTRICTSYN);} break;
case 72:
# line 261
{syntaxError("type definition");} break;
case 73:
# line 263
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(rev(yypvt[-1]),yypvt[-0]),DATATYPE);} break;
case 74:
# line 266
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(qualify(yypvt[-5],rev(yypvt[-1])),
						     yypvt[-0]),DATATYPE);} break;
case 75:
# line 269
{defTycon(2,yypvt[-1],checkTyLhs(yypvt[-0]),
						    ap(NIL,NIL),DATATYPE);} break;
case 76:
# line 271
{defTycon(4,yypvt[-3],yypvt[-0],
						  ap(qualify(yypvt[-2],NIL),
						     NIL),DATATYPE);} break;
case 77:
# line 274
{syntaxError("data definition");} break;
case 78:
# line 276
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(yypvt[-1],yypvt[-0]),NEWTYPE);} break;
case 79:
# line 279
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(qualify(yypvt[-5],yypvt[-1]),
						     yypvt[-0]),NEWTYPE);} break;
case 80:
# line 282
{syntaxError("newtype definition");} break;
case 81:
# line 283
{if (isInt(yypvt[-0])) {
					     needPrims(intOf(yypvt[-0]));
					 } else {
					     syntaxError("needprims decl");
					 }
					 sp-=2;} break;
case 82:
# line 289
{syntaxError("needprims decl");} break;
case 83:
# line 291
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 84:
# line 292
{yyval = yypvt[-0];} break;
case 85:
# line 293
{syntaxError("type defn lhs");} break;
case 86:
# line 295
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 87:
# line 296
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 88:
# line 298
{yyval = gc3(sigdecl(yypvt[-1],singleton(yypvt[-2]),
									yypvt[-0]));} break;
case 89:
# line 300
{yyval = yypvt[-0];} break;
case 90:
# line 302
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 91:
# line 303
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 92:
# line 305
{yyval = gc4(ap(POLYTYPE,
						     pair(rev(yypvt[-2]),yypvt[-0])));} break;
case 93:
# line 307
{yyval = yypvt[-0];} break;
case 94:
# line 309
{yyval = gc3(qualify(yypvt[-2],yypvt[-0]));} break;
case 95:
# line 310
{yyval = yypvt[-0];} break;
case 96:
# line 312
{yyval = gc4(ap(ap(yypvt[-1],bang(yypvt[-2])),yypvt[-0]));} break;
case 97:
# line 313
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 98:
# line 314
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 99:
# line 315
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 100:
# line 316
{yyval = yypvt[-0];} break;
case 101:
# line 317
{yyval = yypvt[-0];} break;
case 102:
# line 318
{yyval = yypvt[-0];} break;
case 103:
# line 319
{yyval = gc4(ap(LABC,pair(yypvt[-3],rev(yypvt[-1]))));} break;
case 104:
# line 320
{yyval = gc3(ap(LABC,pair(yypvt[-2],NIL)));} break;
case 105:
# line 321
{syntaxError("data type definition");} break;
case 106:
# line 323
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 107:
# line 324
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 108:
# line 325
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 109:
# line 327
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 110:
# line 328
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 111:
# line 329
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 112:
# line 330
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 113:
# line 331
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 114:
# line 333
{yyval = gc2(bang(yypvt[-0]));} break;
case 115:
# line 334
{yyval = yypvt[-0];} break;
case 116:
# line 335
{yyval = yypvt[-0];} break;
case 117:
# line 337
{yyval = gc1(singleton(yypvt[-0]));} break;
case 118:
# line 339
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 119:
# line 340
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 120:
# line 342
{yyval = gc3(pair(rev(yypvt[-2]),yypvt[-0]));} break;
case 121:
# line 343
{yyval = gc3(pair(rev(yypvt[-2]),yypvt[-0]));} break;
case 122:
# line 344
{yyval = gc4(pair(rev(yypvt[-3]),bang(yypvt[-0])));} break;
case 123:
# line 346
{yyval = gc0(NIL);} break;
case 124:
# line 347
{yyval = gc2(singleton(yypvt[-0]));} break;
case 125:
# line 348
{yyval = gc4(yypvt[-1]);} break;
case 126:
# line 350
{yyval = gc0(NIL);} break;
case 127:
# line 351
{yyval = gc1(rev(yypvt[-0]));} break;
case 128:
# line 353
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 129:
# line 354
{yyval = gc1(singleton(yypvt[-0]));} break;
case 130:
# line 359
{primDefn(yypvt[-3],yypvt[-2],yypvt[-0]); sp-=4;} break;
case 131:
# line 361
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 132:
# line 362
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 133:
# line 363
{syntaxError("primitive defn");} break;
case 134:
# line 365
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 135:
# line 366
{yyval = yypvt[-0];} break;
case 136:
# line 371
{classDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]); sp-=3;} break;
case 137:
# line 372
{instDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]);  sp-=3;} break;
case 138:
# line 373
{defaultDefn(intOf(yypvt[-3]),yypvt[-1]);  sp-=4;} break;
case 139:
# line 374
{syntaxError("class declaration");} break;
case 140:
# line 375
{syntaxError("instance declaration");} break;
case 141:
# line 376
{syntaxError("default declaration");} break;
case 142:
# line 378
{yyval = gc3(pair(yypvt[-2],checkPred(yypvt[-0])));} break;
case 143:
# line 379
{yyval = gc1(pair(NIL,checkPred(yypvt[-0])));} break;
case 144:
# line 381
{yyval = gc3(pair(yypvt[-2],checkPred(yypvt[-0])));} break;
case 145:
# line 382
{yyval = gc1(pair(NIL,checkPred(yypvt[-0])));} break;
case 146:
# line 384
{yyval = gc0(NIL);} break;
case 147:
# line 385
{yyval = gc1(rev(yypvt[-0]));} break;
case 148:
# line 387
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 149:
# line 388
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 150:
# line 393
{yyval = gc3(qualify(yypvt[-2],yypvt[-0]));} break;
case 151:
# line 394
{yyval = yypvt[-0];} break;
case 152:
# line 396
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 153:
# line 397
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 154:
# line 398
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 155:
# line 399
{yyval = yypvt[-0];} break;
case 156:
# line 401
{yyval = gc4(ap(POLYTYPE,
						     pair(rev(yypvt[-2]),yypvt[-0])));} break;
case 157:
# line 403
{yyval = yypvt[-0];} break;
case 158:
# line 405
{yyval = gc3(yypvt[-1]);} break;
case 159:
# line 407
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 160:
# line 408
{yyval = gc1(singleton(yypvt[-0]));} break;
case 161:
# line 410
{yyval = gc3(qualify(yypvt[-2],yypvt[-0]));} break;
case 162:
# line 411
{yyval = yypvt[-0];} break;
case 163:
# line 413
{yyval = gc2(NIL);} break;
case 164:
# line 414
{yyval = gc1(singleton(checkPred(yypvt[-0])));} break;
case 165:
# line 415
{yyval = gc3(singleton(checkPred(yypvt[-1])));} break;
case 166:
# line 416
{yyval = gc3(checkContext(rev(yypvt[-1])));} break;
case 167:
# line 418
{yyval = gc1(singleton(yypvt[-0]));} break;
case 168:
# line 419
{yyval = gc3(checkContext(rev(yypvt[-1])));} break;
case 169:
# line 421
{
#if TREX
					 yyval = gc3(ap(mkExt(textOf(yypvt[-0])),yypvt[-2]));
#else
					 noTREX("a type context");
#endif
					} break;
case 170:
# line 428
{
#if IPARAM
					 yyval = gc3(pair(mkIParam(yypvt[-2]),yypvt[-0]));
#else
					 noIP("a type context");
#endif
					} break;
case 171:
# line 436
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 172:
# line 437
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 173:
# line 438
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 174:
# line 439
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 175:
# line 440
{yyval = gc1(singleton(yypvt[-0]));} break;
case 176:
# line 444
{yyval = yypvt[-0];} break;
case 177:
# line 445
{yyval = yypvt[-0];} break;
case 178:
# line 447
{yyval = yypvt[-0];} break;
case 179:
# line 448
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 180:
# line 449
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 181:
# line 450
{syntaxError("type expression");} break;
case 182:
# line 452
{yyval = yypvt[-0];} break;
case 183:
# line 453
{yyval = yypvt[-0];} break;
case 184:
# line 455
{yyval = yypvt[-0];} break;
case 185:
# line 456
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 186:
# line 457
{yyval = gc3(fn(yypvt[-2],yypvt[-0]));} break;
case 187:
# line 458
{syntaxError("type expression");} break;
case 188:
# line 460
{yyval = yypvt[-0];} break;
case 189:
# line 461
{yyval = yypvt[-0];} break;
case 190:
# line 463
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 191:
# line 464
{yyval = yypvt[-0];} break;
case 192:
# line 466
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 193:
# line 467
{yyval = yypvt[-0];} break;
case 194:
# line 469
{yyval = yypvt[-0];} break;
case 195:
# line 470
{yyval = yypvt[-0];} break;
case 196:
# line 472
{yyval = yypvt[-0];} break;
case 197:
# line 473
{yyval = yypvt[-0];} break;
case 198:
# line 475
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 199:
# line 476
{yyval = yypvt[-0];} break;
case 200:
# line 478
{yyval = yypvt[-0];} break;
case 201:
# line 479
{yyval = gc2(typeUnit);} break;
case 202:
# line 480
{yyval = gc3(typeArrow);} break;
case 203:
# line 481
{yyval = gc3(yypvt[-1]);} break;
case 204:
# line 482
{yyval = gc3(yypvt[-1]);} break;
case 205:
# line 483
{yyval = gc3(yypvt[-1]);} break;
case 206:
# line 484
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 207:
# line 485
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 208:
# line 486
{yyval = gc3(ap(typeList,yypvt[-1]));} break;
case 209:
# line 487
{yyval = gc2(typeList);} break;
case 210:
# line 488
{h98DoesntSupport(row,"anonymous type variables");
					 yyval = gc1(inventVar());} break;
case 211:
# line 491
{yyval = yypvt[-0];} break;
case 212:
# line 492
{
#if TREX
					 yyval = gc3(revOnto(yypvt[-1],typeNoRow));
#else
					 noTREX("a type");
#endif
					} break;
case 213:
# line 499
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 214:
# line 501
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 215:
# line 502
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 216:
# line 504
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 217:
# line 505
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 218:
# line 506
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 219:
# line 507
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 220:
# line 510
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 221:
# line 511
{yyval = gc1(singleton(yypvt[-0]));} break;
case 222:
# line 513
{h98DoesntSupport(row,"extensible records");
					 yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));} break;
case 223:
# line 520
{yyval = gc3(fixdecl(yypvt[-2],yypvt[-0],NON_ASS,yypvt[-1]));} break;
case 224:
# line 521
{syntaxError("fixity decl");} break;
case 225:
# line 522
{yyval = gc3(fixdecl(yypvt[-2],yypvt[-0],LEFT_ASS,yypvt[-1]));} break;
case 226:
# line 523
{syntaxError("fixity decl");} break;
case 227:
# line 524
{yyval = gc3(fixdecl(yypvt[-2],yypvt[-0],RIGHT_ASS,yypvt[-1]));} break;
case 228:
# line 525
{syntaxError("fixity decl");} break;
case 229:
# line 526
{yyval = gc3(sigdecl(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 230:
# line 527
{syntaxError("type signature");} break;
case 231:
# line 529
{yyval = gc1(checkPrec(yypvt[-0]));} break;
case 232:
# line 530
{yyval = gc0(mkInt(DEF_PREC));} break;
case 233:
# line 532
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 234:
# line 533
{yyval = gc1(singleton(yypvt[-0]));} break;
case 235:
# line 535
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 236:
# line 536
{yyval = gc1(singleton(yypvt[-0]));} break;
case 237:
# line 538
{yyval = gc3(yypvt[-1]);} break;
case 238:
# line 539
{yyval = gc3(yypvt[-1]);} break;
case 239:
# line 541
{yyval = gc0(NIL);} break;
case 240:
# line 542
{yyval = gc2(yypvt[-1]);} break;
case 241:
# line 543
{yyval = gc2(yypvt[-1]);} break;
case 242:
# line 545
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 243:
# line 547
{yyval = yypvt[-0];} break;
case 244:
# line 548
{yyval = gc2(ap(FUNBIND,pair(yypvt[-1],yypvt[-0])));} break;
case 245:
# line 549
{yyval = gc4(ap(FUNBIND,
						     pair(yypvt[-3],ap(RSIGN,
								ap(yypvt[-0],yypvt[-1])))));} break;
case 246:
# line 552
{yyval = gc2(ap(PATBIND,pair(yypvt[-1],yypvt[-0])));} break;
case 247:
# line 554
{yyval = yypvt[-0];} break;
case 248:
# line 555
{yyval = yypvt[-0];} break;
case 249:
# line 556
{yyval = yypvt[-0];} break;
case 250:
# line 558
{yyval = gc3(ap2(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 251:
# line 559
{yyval = gc3(ap2(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 252:
# line 560
{yyval = gc3(ap2(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 253:
# line 561
{yyval = gc3(ap2(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 254:
# line 562
{yyval = gc3(ap2(varPlus,yypvt[-2],yypvt[-0]));} break;
case 255:
# line 564
{yyval = gc4(ap(yypvt[-2],yypvt[-0]));} break;
case 256:
# line 565
{yyval = gc4(ap(yypvt[-2],yypvt[-0]));} break;
case 257:
# line 566
{yyval = gc4(ap(yypvt[-2],yypvt[-0]));} break;
case 258:
# line 567
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 259:
# line 568
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 260:
# line 570
{yyval = gc2(letrec(yypvt[-0],yypvt[-1]));} break;
case 261:
# line 571
{syntaxError("declaration");} break;
case 262:
# line 573
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 263:
# line 574
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 264:
# line 576
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 265:
# line 577
{yyval = gc1(singleton(yypvt[-0]));} break;
case 266:
# line 579
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 267:
# line 581
{yyval = gc0(NIL);} break;
case 268:
# line 582
{yyval = gc2(yypvt[-0]);} break;
case 269:
# line 587
{yyval = yypvt[-0];} break;
case 270:
# line 588
{yyval = yypvt[-0];} break;
case 271:
# line 590
{yyval = gc3(ap(ESIGN,pair(yypvt[-2],yypvt[-0])));} break;
case 272:
# line 591
{yyval = yypvt[-0];} break;
case 273:
# line 593
{yyval = gc3(ap2(varPlus,yypvt[-2],yypvt[-0]));} break;
case 274:
# line 595
{yyval = yypvt[-0];} break;
case 275:
# line 596
{yyval = yypvt[-0];} break;
case 276:
# line 597
{yyval = yypvt[-0];} break;
case 277:
# line 599
{yyval = yypvt[-0];} break;
case 278:
# line 600
{yyval = yypvt[-0];} break;
case 279:
# line 602
{yyval = yypvt[-0];} break;
case 280:
# line 603
{yyval = gc1(ap(INFIX,yypvt[-0]));} break;
case 281:
# line 605
{yyval = gc2(ap(NEG,only(yypvt[-0])));} break;
case 282:
# line 606
{syntaxError("pattern");} break;
case 283:
# line 607
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 284:
# line 608
{yyval = gc4(ap(NEG,ap2(yypvt[-2],only(yypvt[-3]),yypvt[-0])));} break;
case 285:
# line 609
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 286:
# line 610
{yyval = gc4(ap(NEG,ap2(yypvt[-2],only(yypvt[-3]),yypvt[-0])));} break;
case 287:
# line 611
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 288:
# line 612
{yyval = gc4(ap(NEG,ap2(yypvt[-2],only(yypvt[-3]),yypvt[-0])));} break;
case 289:
# line 613
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 290:
# line 614
{yyval = gc4(ap(NEG,ap(ap(yypvt[-2],yypvt[-3]),yypvt[-0])));} break;
case 291:
# line 616
{yyval = yypvt[-0];} break;
case 292:
# line 617
{yyval = yypvt[-0];} break;
case 293:
# line 619
{yyval = yypvt[-0];} break;
case 294:
# line 620
{yyval = yypvt[-0];} break;
case 295:
# line 622
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 296:
# line 623
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 297:
# line 625
{yyval = yypvt[-0];} break;
case 298:
# line 626
{yyval = yypvt[-0];} break;
case 299:
# line 627
{yyval = yypvt[-0];} break;
case 300:
# line 629
{yyval = gc3(ap(ASPAT,pair(yypvt[-2],yypvt[-0])));} break;
case 301:
# line 630
{yyval = yypvt[-0];} break;
case 302:
# line 631
{yyval = gc4(ap(CONFLDS,pair(yypvt[-3],yypvt[-1])));} break;
case 303:
# line 632
{yyval = yypvt[-0];} break;
case 304:
# line 633
{yyval = yypvt[-0];} break;
case 305:
# line 634
{yyval = gc1(WILDCARD);} break;
case 306:
# line 635
{yyval = gc3(yypvt[-1]);} break;
case 307:
# line 636
{yyval = gc3(yypvt[-1]);} break;
case 308:
# line 637
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 309:
# line 638
{yyval = gc3(ap(FINLIST,rev(yypvt[-1])));} break;
case 310:
# line 639
{yyval = gc2(ap(LAZYPAT,yypvt[-0]));} break;
case 311:
# line 641
{
#if TREX
					 yyval = gc3(revOnto(yypvt[-1],nameNoRec));
#else
					 yyval = gc3(NIL);
#endif
					} break;
case 312:
# line 648
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 313:
# line 651
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 314:
# line 652
{yyval = gc3(cons(yypvt[-0],singleton(yypvt[-2])));} break;
case 315:
# line 654
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 316:
# line 655
{yyval = gc1(singleton(yypvt[-0]));} break;
case 317:
# line 657
{yyval = gc0(NIL);} break;
case 318:
# line 658
{yyval = gc1(rev(yypvt[-0]));} break;
case 319:
# line 660
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 320:
# line 661
{yyval = gc1(singleton(yypvt[-0]));} break;
case 321:
# line 663
{yyval = gc3(pair(yypvt[-2],yypvt[-0]));} break;
case 322:
# line 664
{yyval = yypvt[-0];} break;
case 323:
# line 667
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 324:
# line 668
{yyval = gc1(singleton(yypvt[-0]));} break;
case 325:
# line 670
{
#if TREX
					 yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));
#else
					 noTREX("a pattern");
#endif
					} break;
case 326:
# line 682
{yyval = yypvt[-0];} break;
case 327:
# line 683
{syntaxError("expression");} break;
case 328:
# line 685
{yyval = gc3(ap(ESIGN,pair(yypvt[-2],yypvt[-0])));} break;
case 329:
# line 686
{
#if IPARAM
					 yyval = gc3(ap(DWHRE,pair(yypvt[-2],yypvt[-0])));
#else
					 noIP("an expression");
#endif
					} break;
case 330:
# line 693
{yyval = yypvt[-0];} break;
case 331:
# line 695
{yyval = yypvt[-0];} break;
case 332:
# line 696
{yyval = yypvt[-0];} break;
case 333:
# line 698
{yyval = gc1(ap(INFIX,yypvt[-0]));} break;
case 334:
# line 699
{yyval = yypvt[-0];} break;
case 335:
# line 701
{yyval = gc1(ap(INFIX,yypvt[-0]));} break;
case 336:
# line 702
{yyval = yypvt[-0];} break;
case 337:
# line 704
{yyval = gc4(ap(NEG,ap(ap(yypvt[-2],yypvt[-3]),yypvt[-0])));} break;
case 338:
# line 705
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 339:
# line 706
{yyval = gc2(ap(NEG,only(yypvt[-0])));} break;
case 340:
# line 707
{yyval = gc4(ap(NEG,
						     ap(ap(yypvt[-2],only(yypvt[-3])),yypvt[-0])));} break;
case 341:
# line 709
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 342:
# line 711
{yyval = gc4(ap(NEG,ap(ap(yypvt[-2],yypvt[-3]),yypvt[-0])));} break;
case 343:
# line 712
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 344:
# line 713
{yyval = gc2(ap(NEG,only(yypvt[-0])));} break;
case 345:
# line 714
{yyval = gc4(ap(NEG,
						     ap(ap(yypvt[-2],only(yypvt[-3])),yypvt[-0])));} break;
case 346:
# line 716
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 347:
# line 718
{yyval = gc6(ap(CASE,pair(yypvt[-4],rev(yypvt[-1]))));} break;
case 348:
# line 719
{yyval = gc4(ap(DOCOMP,checkDo(yypvt[-1])));} break;
case 349:
# line 720
{yyval = yypvt[-0];} break;
case 350:
# line 722
{yyval = gc4(ap(LAMBDA,      
						     pair(rev(yypvt[-2]),
							  pair(yypvt[-1],yypvt[-0]))));} break;
case 351:
# line 725
{yyval = gc4(letrec(yypvt[-2],yypvt[-0]));} break;
case 352:
# line 726
{yyval = gc6(ap(COND,triple(yypvt[-4],yypvt[-2],yypvt[-0])));} break;
case 353:
# line 727
{
#if IPARAM
					 yyval = gc4(ap(DWHRE,pair(yypvt[-0],yypvt[-2])));
#else
					 noIP("an expression");
#endif
					} break;
case 354:
# line 735
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 355:
# line 736
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 356:
# line 738
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 357:
# line 739
{yyval = yypvt[-0];} break;
case 358:
# line 741
{yyval = yypvt[-0];} break;
case 359:
# line 742
{yyval = gc3(ap(ASPAT,pair(yypvt[-2],yypvt[-0])));} break;
case 360:
# line 743
{yyval = gc2(ap(LAZYPAT,yypvt[-0]));} break;
case 361:
# line 744
{yyval = yypvt[-0];} break;
case 362:
# line 745
{yyval = gc1(WILDCARD);} break;
case 363:
# line 746
{yyval = yypvt[-0];} break;
case 364:
# line 747
{yyval = gc4(ap(CONFLDS,pair(yypvt[-3],yypvt[-1])));} break;
case 365:
# line 748
{yyval = gc4(ap(UPDFLDS,
						     triple(yypvt[-3],NIL,yypvt[-1])));} break;
case 366:
# line 750
{yyval = yypvt[-0];} break;
case 367:
# line 751
{yyval = yypvt[-0];} break;
case 368:
# line 752
{yyval = yypvt[-0];} break;
case 369:
# line 753
{yyval = yypvt[-0];} break;
case 370:
# line 754
{yyval = gc3(yypvt[-1]);} break;
case 371:
# line 755
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 372:
# line 757
{
#if TREX
					 yyval = gc3(revOnto(yypvt[-1],nameNoRec));
#else
					 yyval = gc3(NIL);
#endif
					} break;
case 373:
# line 764
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 374:
# line 765
{yyval = yypvt[-0];} break;
case 375:
# line 767
{yyval = gc3(yypvt[-1]);} break;
case 376:
# line 768
{yyval = gc4(ap(yypvt[-1],yypvt[-2]));} break;
case 377:
# line 769
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 378:
# line 770
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 379:
# line 772
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 380:
# line 773
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 381:
# line 776
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 382:
# line 777
{yyval = gc1(singleton(yypvt[-0]));} break;
case 383:
# line 779
{
#if TREX
					 yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));
#else
					 noTREX("an expression");
#endif
					} break;
case 384:
# line 788
{yyval = yypvt[-0];} break;
case 385:
# line 789
{yyval = gc2(yypvt[-1]);} break;
case 386:
# line 791
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 387:
# line 792
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 388:
# line 794
{yyval = gc3(pair(yypvt[-2],letrec(yypvt[-0],yypvt[-1])));} break;
case 389:
# line 796
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 390:
# line 797
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 391:
# line 798
{syntaxError("case expression");} break;
case 392:
# line 800
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 393:
# line 801
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 394:
# line 803
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 395:
# line 805
{yyval = gc2(yypvt[-1]);} break;
case 396:
# line 806
{yyval = yypvt[-0];} break;
case 397:
# line 808
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 398:
# line 809
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 399:
# line 811
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 400:
# line 812
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 401:
# line 814
{yyval = gc1(ap(DOQUAL,yypvt[-0]));} break;
case 402:
# line 816
{yyval = gc0(NIL);} break;
case 403:
# line 817
{yyval = gc1(rev(yypvt[-0]));} break;
case 404:
# line 819
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 405:
# line 820
{yyval = gc1(singleton(yypvt[-0]));} break;
case 406:
# line 822
{yyval = yypvt[-0];} break;
case 407:
# line 823
{yyval = gc3(pair(yypvt[-2],yypvt[-0]));} break;
case 408:
# line 825
{yyval = gc3(yypvt[-1]);} break;
case 409:
# line 826
{yyval = gc3(yypvt[-1]);} break;
case 410:
# line 828
{yyval = gc0(NIL);} break;
case 411:
# line 829
{yyval = gc2(yypvt[-1]);} break;
case 412:
# line 830
{yyval = gc2(yypvt[-1]);} break;
case 413:
# line 832
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 414:
# line 834
{yyval = gc3(pair(yypvt[-2],yypvt[-0]));} break;
case 415:
# line 835
{yyval = gc1(pair(yypvt[-0],yypvt[-0]));} break;
case 416:
# line 840
{yyval = gc1(ap(FINLIST,cons(yypvt[-0],NIL)));} break;
case 417:
# line 841
{yyval = gc1(ap(FINLIST,rev(yypvt[-0])));} break;
case 418:
# line 842
{yyval = gc3(ap(COMP,pair(yypvt[-2],rev(yypvt[-0]))));} break;
case 419:
# line 843
{yyval = gc3(ap(ap(nameFromTo,yypvt[-2]),yypvt[-0]));} break;
case 420:
# line 844
{yyval = gc4(ap(ap(nameFromThen,yypvt[-3]),yypvt[-1]));} break;
case 421:
# line 845
{yyval = gc2(ap(nameFrom,yypvt[-1]));} break;
case 422:
# line 846
{yyval = gc5(ap(ap(ap(nameFromThenTo,
								yypvt[-4]),yypvt[-2]),yypvt[-0]));} break;
case 423:
# line 849
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 424:
# line 850
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 425:
# line 852
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 426:
# line 853
{yyval = gc1(ap(BOOLQUAL,yypvt[-0]));} break;
case 427:
# line 854
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 428:
# line 859
{yyval = yypvt[-0];} break;
case 429:
# line 860
{yyval = gc2(nameUnit);} break;
case 430:
# line 861
{yyval = gc2(nameNil);} break;
case 431:
# line 862
{yyval = gc3(yypvt[-1]);} break;
case 432:
# line 864
{yyval = gc2(mkTuple(tupleOf(yypvt[-1])+1));} break;
case 433:
# line 865
{yyval = gc1(mkTuple(2));} break;
case 434:
# line 867
{yyval = yypvt[-0];} break;
case 435:
# line 868
{yyval = gc1(varHiding);} break;
case 436:
# line 869
{yyval = gc1(varQualified);} break;
case 437:
# line 870
{yyval = gc1(varAsMod);} break;
case 438:
# line 872
{yyval = yypvt[-0];} break;
case 439:
# line 873
{yyval = yypvt[-0];} break;
case 440:
# line 875
{yyval = yypvt[-0];} break;
case 441:
# line 876
{yyval = gc3(yypvt[-1]);} break;
case 442:
# line 877
{yyval = gc3(varPlus);} break;
case 443:
# line 878
{yyval = gc3(varMinus);} break;
case 444:
# line 879
{yyval = gc3(varBang);} break;
case 445:
# line 880
{yyval = gc3(varDot);} break;
case 446:
# line 882
{yyval = yypvt[-0];} break;
case 447:
# line 883
{yyval = gc3(yypvt[-1]);} break;
case 448:
# line 884
{yyval = yypvt[-0];} break;
case 449:
# line 886
{yyval = yypvt[-0];} break;
case 450:
# line 887
{yyval = gc3(yypvt[-1]);} break;
case 451:
# line 889
{yyval = yypvt[-0];} break;
case 452:
# line 890
{yyval = gc3(yypvt[-1]);} break;
case 453:
# line 891
{yyval = yypvt[-0];} break;
case 454:
# line 893
{yyval = gc1(varPlus);} break;
case 455:
# line 894
{yyval = gc1(varMinus);} break;
case 456:
# line 895
{yyval = yypvt[-0];} break;
case 457:
# line 897
{yyval = gc1(varPlus);} break;
case 458:
# line 898
{yyval = yypvt[-0];} break;
case 459:
# line 900
{yyval = gc1(varMinus);} break;
case 460:
# line 901
{yyval = yypvt[-0];} break;
case 461:
# line 903
{yyval = yypvt[-0];} break;
case 462:
# line 904
{yyval = gc3(yypvt[-1]);} break;
case 463:
# line 905
{yyval = gc1(varBang);} break;
case 464:
# line 906
{yyval = gc1(varDot);} break;
case 465:
# line 908
{yyval = gc1(varMinus);} break;
case 466:
# line 909
{yyval = yypvt[-0];} break;
case 467:
# line 911
{yyval = yypvt[-0];} break;
case 468:
# line 912
{yyval = gc3(yypvt[-1]);} break;
case 469:
# line 913
{yyval = yypvt[-0];} break;
case 470:
# line 916
{yyval = yypvt[-0];} break;
case 471:
# line 917
{yyval = gc3(yypvt[-1]);} break;
case 472:
# line 919
{yyval = yypvt[-0];} break;
case 473:
# line 920
{yyval = gc3(yypvt[-1]);} break;
case 474:
# line 921
{yyval = yypvt[-0];} break;
case 475:
# line 923
{yyval = yypvt[-0];} break;
case 476:
# line 924
{yyval = yypvt[-0];} break;
case 477:
# line 926
{yyval = yypvt[-0];} break;
case 478:
# line 927
{yyval = yypvt[-0];} break;
case 479:
# line 932
{yyerrok; goOffside(startColumn);} break;
case 480:
# line 935
{yyval = yypvt[-0];} break;
case 481:
# line 936
{yyerrok; 
					 if (canUnOffside()) {
					     unOffside();
					     /* insert extra token on stack*/
					     push(NIL);
					     pushed(0) = pushed(1);
					     pushed(1) = mkInt(column);
					 }
					 else
					     syntaxError("definition");
					} break;/* End of actions */
    }
    goto yystack;  /* stack new state and value */

}
